/* mondo-newt.c

Created on August 9th, 2001
See mondo-restore.c's header for list of changes

Last modified on November 9th, 2001

*/

#include "my-stuff.h"
#define NO_FLAWS_DETECTED "No flaws are detected in mountlist at this time. Hit 'OK' to proceed."

extern int run_program_and_log_output(char*);


newtComponent g_progressForm, g_blurb1, g_blurb2, g_blurb3, g_label, g_timeline, g_percentline, g_scale;
char err_log_lines[NOOF_ERR_LINES][MAX_STR_LEN], g_blurb_str_1[MAX_STR_LEN], g_blurb_str_2[MAX_STR_LEN],g_blurb_str_3[MAX_STR_LEN];
void popup_and_OK(char*);
int ask_me_yes_or_no(char*);
int popup_with_buttons(char*,char*,char*);



extern g_start_time, g_minimum_progress, g_maximum_progress, 
  g_current_progress, g_currentY;
extern int what_number_cd_is_this(void);
extern int make_list_of_drives(struct mountlist_itself*,char[ARBITRARY_MAXIMUM][MAX_STR_LEN]);


char *mountlist_to_string(struct mountlist_itself *, int);

void log_to_screen(char*);
void refresh_log_screen(void);


void open_evalcall_form(char*);
void update_evalcall_form(int);
void close_evalcall_form(void);



char *number_to_text(int i)
{
  static char output[MAX_STR_LEN];
  switch(i)
    {
    case 0:
      strcpy(output,"Zero");
      break;
    case 1:
      strcpy(output,"One");
      break;
    case 2:
      strcpy(output,"Two");
      break;
    case 3:
      strcpy(output,"Three");
      break;
    case 4:
      strcpy(output,"Four");
      break;
    case 5:
      strcpy(output,"Five");
      break;
    case 6:
      strcpy(output,"Six");
      break;
    case 7:
      strcpy(output,"Seven");
      break;
    case 8:
      strcpy(output,"Eight");
      break;
    case 9:
      strcpy(output,"Nine");
    case 10:
      strcpy(output,"Ten");
    default:
      sprintf(output,"%d",i);
    }
  return(output);
}



void center_string(char*in_out,int width)
{
  char scratch[MAX_STR_LEN],*p;
  int i,len,mid,x;
  for(p=in_out; *p==' '; p++);
  strcpy(scratch,p);
  len=strlen(scratch);
  mid = width/2;
  x = mid - len/2;
  for(i=0;i<x;i++)
    { in_out[i]=' '; }
  in_out[i]='\0';
  strcat(in_out,scratch);
}

char *leftpad_string(char*incoming,int width)
{
  static char output[MAX_STR_LEN];
  int i,len,x;
  strcpy(output,incoming);
  for(i=strlen(output); i<width;i++) { output[i]=' '; }
  output[i]='\0';
  return(output);
}



char which_restore_mode()
{
  char output;
  newtComponent b1,b2,b3,b4,b_res, myForm;

  newtPushHelpLine("   Do you want to 'nuke' your system, restore interactively, or just compare?");
  newtOpenWindow(24,4,32,17,"How should I restore?");
  b1 = newtButton(7,1,"Automatically");
  b2 = newtButton(7,5,"Interactively");
  b3 = newtButton(7,9,"Compare only!");
  b4 = newtButton(7,13,"Exit to shell");
  myForm = newtForm(NULL, NULL, 0);
  newtFormAddComponents(myForm, b1, b2, b3, b4, NULL);
  b_res = newtRunForm(myForm);
  newtFormDestroy(myForm);
  newtPopWindow();
  if (b_res == b1) { output='N'; }
  if (b_res == b2) { output='I'; }
  if (b_res == b3) { output='C'; }
  if (b_res == b4) { output='E'; }
  newtPopHelpLine();
  return(output);
}


void nuke_mode_dummy()
{
  newtComponent myForm, b1, b2, b3, b_res;
  newtPushHelpLine("This is where I nuke your hard drives. Mhahahahaha. No-one can stop Mojo Jojo!");
  newtOpenWindow(24,3,32,13,"Nuking");
  b1=newtButton(7,1,"Slowly");
  b2=newtButton(7,5,"Medium");
  b3=newtButton(7,9,"Quickly");
  myForm = newtForm(NULL,NULL,0);
  newtFormAddComponents(myForm,b1,b2,b3,NULL);
  b_res=newtRunForm(myForm);
  newtFormDestroy(myForm);
  newtPopWindow();
  newtPopHelpLine();
}



void setup_newt_stuff()
{
  int i;
  newtComponent myForm, b1, b2, b3, b_res;
  for(i=0;i<NOOF_ERR_LINES;i++)
    {
      err_log_lines[i][0]='\0';
    }
  newtInit();
  newtCls();
  newtPushHelpLine("Welcome to Mondo Rescue, by Hugo Rabson and the Internet. All rights reversed.");
  //  newtDrawRootText(28,0,"Welcome to Mondo Rescue");
  newtDrawRootText(18,0,"W E L C O M E   T O   M O N D O   R E S C U E");
}


void mvaddstr_and_log_it(int y, int x, char *output)
{
  log_it(output);
  newtDrawRootText(x,y,output);
  newtRefresh();
}




void log_file_end_to_screen(char*filename,char*grep_for_me)
{
  char command[MAX_STR_LEN+1],tmp[MAX_STR_LEN+1];
  FILE*fin;
  int i;
  if (!does_file_exist(filename))
    {return;}
  if (grep_for_me[0]!='\0') 
    {
      sprintf(command,"cat %s | grep \"%s\" | tail -n%d", filename, grep_for_me, NOOF_ERR_LINES);
    }
  else
    {
      sprintf(command,"cat %s | tail -n%d", filename, NOOF_ERR_LINES);
    }
  fin=popen(command,"r");
  if (fin)
    {
      for(i=0;i<NOOF_ERR_LINES;i++)
	{
	  fgets(err_log_lines[i],MAX_STR_LEN,fin);
	  if (feof(fin)) {break;}
	}
      pclose(fin);
    }
  refresh_log_screen();
}



void log_to_screen(char *op)
{
  int i, j;
  char tmp[MAX_STR_LEN+1], output[MAX_STR_LEN];
  strcpy(output,op);
  log_it(output);
  for(i=1; i< NOOF_ERR_LINES; i++)
    {
      strcpy(err_log_lines[i-1],"                                                                                ");
      strcpy(err_log_lines[i-1],err_log_lines[i]);
    }
  output[80]='\0';
  while( output[strlen(output)-1]<32)
    { output[strlen(output)-1]='\0'; }
  for(j=0; j<strlen(output); j++)
    {
      if (output[j]<32) 
	{
	  /*
	  if (output[j]==8)
	    {
	      strcpy(tmp,output+j+1);
	      strcpy(output+j-1,tmp);
	      j-=2;
	      if (j<-1) {j=-1;}
	    }
	  else
	    {
	  */
	      output[j]=' ';
	      //	    }
	}
    }
  strcpy(err_log_lines[NOOF_ERR_LINES-1],output);
  refresh_log_screen();
}



void refresh_log_screen()
{
  int i;
  for(i=NOOF_ERR_LINES-1; i>=0; i--)
    {
      newtDrawRootText(0,i+23-NOOF_ERR_LINES,"                                                                                ");
      newtDrawRootText(0,i+23-NOOF_ERR_LINES,err_log_lines[i]);
    }
  newtRefresh();
}



void strip_spaces(char *in_out)
{
  char tmp[MAX_STR_LEN],*p;
  int i;
  for(i=0;in_out[i]==' ';i++);
  strcpy(tmp,in_out+i);
  for(i=strlen(tmp); tmp[i-1]==' ';i--);
  tmp[i]='\0';
  strcpy(in_out,tmp);
}



void finish(int signal)
{
  char c,tmp[MAX_STR_LEN];
  if (signal==0) { popup_and_OK("Please press <enter> to quit."); }

  // newtPopHelpLine();
  newtFinished();
  // system("clear");
  if (does_file_exist("/tmp/mondo-archive.log"))
    {
      printf("Type 'less /tmp/mondo-archive.log' to see the output log\n");
    }
  exit(signal);
}


void update_progress_form_full(char*,char*,char*);


void update_progress_form(char *blurb3)
{
  //  log_it("update_progress_form --- called");
  if (g_current_progress==-999)
    {
      log_it("You're trying to update progress form when it ain't open. Aww, that's OK. I'll let it go. It's a bit naughty but it's a nonfatal error. No prob, Bob.");
      return;
    }
  strcpy(g_blurb_str_3,blurb3);
  update_progress_form_full(g_blurb_str_1, g_blurb_str_2, g_blurb_str_3);
  //  log_it("update_progress_form --- leaving");
}



void update_progress_form_full(char *blurb1, char*blurb2, char*blurb3)
{
  long current_time, time_taken=0, time_remaining=0, time_total_est=0;
  int percentage, range, currX, i, leftX, rightX;
  char tmp[MAX_STR_LEN], percentline_str[MAX_STR_LEN], timeline_str[MAX_STR_LEN];
  current_time=get_time();
  time_taken = current_time - g_start_time;
  if (g_maximum_progress==0)
    {
      percentage=0;
    }
  else
    {
      if (g_current_progress > g_maximum_progress) 
	{ g_maximum_progress = g_current_progress; }
      percentage = (int)((g_current_progress * 100L) / g_maximum_progress);
    }
  if (!percentage) { percentage=1; }
  if (percentage > 100) { percentage = 100; }
  if (percentage < 0) { percentage = 0; }
  time_total_est = time_taken * 100L / (long)(percentage);
  time_remaining = time_total_est - time_taken;
  sprintf(timeline_str,"%2ld:%02ld taken               %2ld:%02ld remaining  ",time_taken / 60, time_taken % 60, time_remaining / 60, time_remaining % 60);
  sprintf(percentline_str," %3d%% done                 %3d%% to go",percentage,100-percentage);
  center_string(blurb1,54);
  center_string(blurb2,54);
  center_string(blurb3,54);
  newtLabelSetText(g_blurb1, blurb1);
  newtLabelSetText(g_blurb2, blurb2);
  newtLabelSetText(g_blurb3, blurb3);
  newtScaleSet(g_scale, g_current_progress);
  newtLabelSetText(g_timeline, timeline_str);
  newtLabelSetText(g_percentline, percentline_str);
  newtDrawRootText(13,11,"");
  newtRefresh();
}




void redraw_mountlist(struct mountlist_itself*mountlist, void *keylist[ARBITRARY_MAXIMUM], newtComponent listbox)
{
  int i;
  newtListboxClear(listbox);
  for(i=0; i<ARBITRARY_MAXIMUM; i++) { keylist[i]=(void*)i; }
  for(i=0; i<mountlist->entries; i++)
    {
      newtListboxAppendEntry(listbox,mountlist_to_string(mountlist,i),keylist[i]);
    }
}


void insist_on_this_cd_number(int cd_number_i_want)
{
  int res;
  char tmp[MAX_STR_LEN],request[MAX_STR_LEN],c;
  newtComponent myForm, b_OK;

  if (what_number_cd_is_this()!=cd_number_i_want)
    {
      if (!does_file_exist("/mnt/cdrom/archives/NOT-THE-LAST")) 
	{
	  log_to_screen("This is the last CD. Why am I asking for 'next'?");
	  return;
	}
      sprintf(tmp,"Insisting on CD #%d",cd_number_i_want);
      sprintf(request,"Please insert CD #%d and press Enter.",cd_number_i_want);
      log_it(tmp);
      while (what_number_cd_is_this()!=cd_number_i_want)
	{
	  system("sync");
	  res=run_program_and_log_output("umount /mnt/cdrom");
	  if (res) { log_to_screen("WARNING - failed to unmount CD-ROM drive"); }
	  res=run_program_and_log_output("eject /dev/cdrom");
	  if (res) { log_to_screen("WARNING - failed to eject CD-ROM disk"); }
	  popup_and_OK(request);
	  system("eject -t /dev/cdrom");
	  system("sync");
	}
      log_it("Thankyou. Proceeding...");
    }
}



int popup_with_buttons(char*p, char *button1, char*button2)
{
  char c, prompt[MAX_STR_LEN];

  newtComponent myForm, b_1, b_2, b_res, text;
  strcpy(prompt,p);
  text = newtTextboxReflowed(2,1,prompt,26,5,5,0);
  b_1 = newtButton(6 + (button2[0]=='\0')*7, newtTextboxGetNumLines(text)+3,button1);
  if (button2[0]!='\0') { b_2 = newtButton(18, newtTextboxGetNumLines(text)+3,"No"); } else { b_2 = NULL; }
  newtOpenWindow(30,5,32,newtTextboxGetNumLines(text)+7,"Alert");
  myForm = newtForm(NULL,NULL,0);
  newtFormAddComponents(myForm, text, b_1, b_2, NULL);
  center_string(prompt,80);
  newtPushHelpLine(prompt);
  b_res = newtRunForm(myForm);
  newtPopHelpLine();
  newtFormDestroy(myForm);
  newtPopWindow();
  if (b_res == b_1) { return(TRUE); } else { return(FALSE); }
}


int popup_and_get_string(char*title, char*b, char*output)
{
  newtComponent myForm, b_1, b_2, b_res, text, type_here;
  char *entry_value, blurb[MAX_STR_LEN];
  strcpy(blurb,b);
  text = newtTextboxReflowed(2,1,blurb,28,5,5,0);
  output[0]='\0';
  type_here = newtEntry(5, newtTextboxGetNumLines(text)+2,"/", 22, &entry_value, NEWT_FLAG_RETURNEXIT);
  b_1 = newtButton(5, newtTextboxGetNumLines(text)+4,"  OK  ");
  b_2 = newtButton(17,newtTextboxGetNumLines(text)+4,"Cancel");
  newtOpenWindow(30,5,32,newtTextboxGetNumLines(text)+9,title);
  myForm=newtForm(NULL,NULL,0);
  newtFormAddComponents(myForm, text, type_here, b_1, b_2, NULL);
  center_string(blurb,80);
  newtPushHelpLine(blurb);
  b_res = newtRunForm(myForm);
  strcpy(output,entry_value);
  newtPopHelpLine();
  newtFormDestroy(myForm);
  newtPopWindow();
  if (b_res == b_2) { return(FALSE); } else { return(TRUE); }
}



int ask_me_yes_or_no(char*prompt)
{
  return(popup_with_buttons(prompt,"Yes","No"));
}


void popup_and_OK(char*prompt)
{
  popup_with_buttons(prompt,"OK","");
}


void open_progress_form(char*title, char*b1, char*b2, char*b3, long max_val)
{
  char b1c[MAX_STR_LEN],blurb1[MAX_STR_LEN], blurb2[MAX_STR_LEN], blurb3[MAX_STR_LEN];
  strcpy(blurb1,b1);
  strcpy(blurb2,b2);
  strcpy(blurb3,b3);
  strcpy(b1c,b1);
  center_string(b1c,80);
  if (max_val<=0) { max_val=1; }
  log_it("open_progress_form was called");
  g_start_time=get_time();
  g_maximum_progress=max_val;
  g_current_progress=0;
  g_blurb1 = newtLabel(2,1,blurb1);
  g_blurb2 = newtLabel(2,2,blurb2);
  g_blurb3 = newtLabel(2,4,blurb3);
  strcpy(g_blurb_str_1,blurb1);
  strcpy(g_blurb_str_2,blurb2);
  strcpy(g_blurb_str_3,blurb3);
  newtOpenWindow(10,4,60,11,title);
  g_scale = newtScale(3,6,54,g_maximum_progress);
  g_progressForm = newtForm(NULL,NULL,0);
  g_timeline = newtLabel(10,8,"This is the timeline");
  g_percentline = newtLabel(10,9,"This is the percentline");
  newtFormAddComponents(g_progressForm, g_percentline, g_timeline, g_scale, g_blurb1, g_blurb2, g_blurb3, NULL);
  
  newtPushHelpLine(b1c);
  newtRefresh();
  update_progress_form_full(blurb1,blurb2,blurb3);
}


void close_progress_form()
{
  log_it("close_progress_form was called");
  if (g_current_progress==-999)
    {
      log_it("Trying to close the progress form when it ain't open!");
      return;
    }
  g_current_progress = g_maximum_progress;
  update_progress_form("Complete");
  sleep(1);
  newtPopHelpLine();
  newtFormDestroy(g_progressForm);
  newtPopWindow();
  g_current_progress=-999;
}


/* I'm not racist against white people. I just don't like people who think Liberia is near Spain.       - Hugo, 09/01/2001 */


char *mountlist_to_string(struct mountlist_itself *mountlist, int lino)
{
  static char output[MAX_STR_LEN];
  sprintf(output,"%-24s %-24s %-10s %8ld",mountlist->el[lino].device, mountlist->el[lino].mountpoint, mountlist->el[lino].format, mountlist->el[lino].size/1024);
  return(output);
}



int find_device_in_mountlist(struct mountlist_itself *mountlist, char*device)
{
  int i;
  for(i=0; i< mountlist->entries && strcmp(mountlist->el[i].device, device)!=0; i++);
  if (i==mountlist->entries)
    {
      return(-1);
    }
  else
    {
      return(i);
    }
}



long get_phys_size_of_drive(char*drive)
{
  FILE*fin;
  char tmp[MAX_STR_LEN], command[MAX_STR_LEN], *p;
  long outL;
  p=strrchr(drive,(int)'/');
  if (p) { strcpy(tmp,p+1); } else { return(-1); }
  sprintf(command,"dmesg | grep %s",tmp);
  fin=popen(command,"r");
  fgets(tmp,MAX_STR_LEN-1,fin);
  while(!feof(fin) && !strstr(tmp,"GB") && !strstr(tmp,"MB"))
    {
      fgets(tmp,MAX_STR_LEN-1,fin);
    }
  pclose(fin);
  if (!(p=strstr(tmp,"GB")) && !(p=strstr(tmp,"MB")))
    { return(-1); }
  for(; !isdigit(*(p-1)); p--);
  *p='\0';
  for(p--; isdigit(*(p-1)); p--);
  outL=atol(p);
  if (outL<=0) { return(-1); }
  if (strstr(tmp,"GB")) { outL=outL*1024; }
  return(outL);
}





int evaluate_drive_within_mountlist(struct mountlist_itself *mountlist, char*drive, char*flaws_str)
{
  int prev_part_no, curr_part_no, pos, res=0, mountpoint_copies, device_copies, i;
  char tmp[MAX_STR_LEN], device[MAX_STR_LEN], mountpoint[MAX_STR_LEN];
  long physical_drive_size=0, amount_allocated=0;

  physical_drive_size=get_phys_size_of_drive(drive);
  sprintf(tmp,"%s is %ld MB",drive,physical_drive_size);
  log_it(tmp);
  flaws_str[0]='\0';
  sprintf(tmp,"Evaluating mountlist's drive %s",drive);
  log_it(tmp);
  prev_part_no=0;
  tmp[0]='\0';
  for(curr_part_no=1; curr_part_no<99; curr_part_no++)
    {
      sprintf(device,"%s%d",drive,curr_part_no);
      pos=find_device_in_mountlist(mountlist,device);
      if (pos<0) { continue; }
      strcpy(mountpoint,mountlist->el[pos].mountpoint);
      // gap in the partition list?
      if (curr_part_no-prev_part_no>1)
	{
	  if (prev_part_no == 0)
	    {
	      sprintf(tmp," Gap prior to %s.",device);
	      log_it(tmp); strcat(flaws_str,tmp); res++;
	    }
	  else if (curr_part_no >5 || (curr_part_no <=4 && prev_part_no>0))
	    {
	      sprintf(tmp," Gap between %s%d and %d.",drive,prev_part_no,curr_part_no);
	      log_it(tmp); strcat(flaws_str,tmp); res++;
	    }
	}
      // no spare primary partitions to help accommodate the logical(s)?
      if (curr_part_no>=5 && prev_part_no==4)
	{
	  sprintf(tmp," Partition %s4 is occupied.",drive);
	  log_it(tmp); strcat(flaws_str,tmp); res++;
	}
      // does partition /dev/hdNX exist more than once in the mountlist?
      for(i=0, mountpoint_copies=0, device_copies=0; i < mountlist->entries; i++)     
	{
	  if (!strcmp(device,mountlist->el[i].device)) { device_copies++; }
	}
      if (device_copies > 1)
	{
	  sprintf(tmp," %s %s's.",number_to_text(device_copies),device);
	  if (!strstr(flaws_str,tmp)) {log_it(tmp);strcat(flaws_str,tmp);res++;}
	}
      // silly partition size?
      if (mountlist->el[pos].size < 8192 && strcmp(mountlist->el[pos].mountpoint,"lvm"))
	{
	  sprintf(tmp," %s is tiny!",device);
	  log_it(tmp);strcat(flaws_str,tmp);res++;
	}
      // mountpoint should begin with a slash, unless it is "swap"
      if (strcmp(mountlist->el[pos].mountpoint,"swap") && strcmp(mountlist->el[pos].mountpoint,"lvm") && mountlist->el[pos].mountpoint[0]!='/')
	{
	  sprintf(tmp," %s has a weird mountpoint.",device);
	  log_it(tmp);strcat(flaws_str,tmp);res++;
	}
      // OK, continue with main loop
      amount_allocated += mountlist->el[pos].size/1024;
      prev_part_no=curr_part_no;
    }

  // Over-allocated the disk? Unallocated space on disk?
  if (amount_allocated > physical_drive_size+1)
    {
      sprintf(tmp," %ld MB over-allocated on %s.",amount_allocated-physical_drive_size,drive);
      log_it(tmp); strcat(flaws_str,tmp); res++;
    }
  else if (amount_allocated < physical_drive_size-1)
    { // NOT AN ERROR, JUST A WARNING :-)
      sprintf(tmp," %ld MB unallocated on %s.",physical_drive_size-amount_allocated,drive);
      log_it(tmp), strcat(flaws_str,tmp);
    }
  if (res) { return(FALSE); } else { return(TRUE); }
}



int look_for_duplicate_mountpoints(struct mountlist_itself *mountlist, char*flaws_str)
{
  int res=0, currline, i, copies,last_copy;
  char curr_mountpoint[MAX_STR_LEN],tmp[MAX_STR_LEN];
  for(currline=0;currline < mountlist->entries; currline++)
    {
      strcpy(curr_mountpoint,mountlist->el[currline].mountpoint);
      for(i=0,copies=0,last_copy=-1;i<mountlist->entries;i++)
	{
	  if (!strcmp(mountlist->el[i].mountpoint,curr_mountpoint) && strcmp(mountlist->el[i].mountpoint,"lvm") && strcmp(mountlist->el[i].mountpoint,"swap"))
	    {
	      last_copy=i;
	      copies++;
	    }
	}
      if (copies > 1 && last_copy == currline)
	{
	  sprintf(tmp," %s %s's.",number_to_text(copies),curr_mountpoint); strcat(flaws_str,tmp); log_it(tmp); res++;
	}
    }
  return(res);
}



int look_for_weird_formats(struct mountlist_itself *mountlist, char*flaws_str)
{
  int i, res=0;
  char tmp[MAX_STR_LEN];
  for(i=0;i < mountlist->entries; i++)
    {
      if (!strstr("swap vfat ext2 ext3 xfs vfs jfs reiserfs dos minix coda nfs ntfs hpfs lvm",mountlist->el[i].format))
	{
	  sprintf(tmp," %s has unknown format.",mountlist->el[i].device);
	  log_it(tmp); strcat(flaws_str,tmp); res++;
	}
      else if ((!strcmp(mountlist->el[i].format,"swap") || !strcmp(mountlist->el[i].mountpoint,"swap")) && strcmp(mountlist->el[i].format,mountlist->el[i].mountpoint))
	{
	  sprintf(tmp," %s is half-swap.",mountlist->el[i].device);
	  log_it(tmp); strcat(flaws_str,tmp); res++;
	}
    }
  return(res);
}



int evaluate_mountlist(struct mountlist_itself *mountlist, char*flaws_str_A, char*flaws_str_B,char*flaws_str_C)
{
  char list_of_drives[ARBITRARY_MAXIMUM][MAX_STR_LEN],tmp[MAX_STR_LEN], flaws_str[MAX_STR_LEN];
  int noof_drives, i, res=0;
  noof_drives=make_list_of_drives(mountlist,list_of_drives);
  flaws_str[0]='\0';
  log_it("Evaluating mountlist...");
  for(i=0; i<noof_drives; i++)
    {
      if (!evaluate_drive_within_mountlist(mountlist,list_of_drives[i],tmp))
	{ res++; }
      strcat(flaws_str,tmp);
    }
  res+=look_for_duplicate_mountpoints(mountlist,flaws_str);
  res+=look_for_weird_formats(mountlist,flaws_str);
  //  sprintf(tmp,"Done... res=%d ... if nonzero then return FALSE, else return TRUE",res);
  //  log_it(tmp);
  log_it(flaws_str);
  flaws_str_A[0]=flaws_str_B[0]=flaws_str_C[0]='\0';
  if (!res && !strlen(flaws_str)) { return(TRUE); }
  if (strlen(flaws_str)>0) { sprintf(flaws_str_A,"%s",flaws_str+1); }
  if (strlen(flaws_str_A)>=74)
    {
      for(i=74; flaws_str_A[i]!=' '; i--);
      strcpy(flaws_str_B,flaws_str_A+i+1);
      flaws_str_A[i]='\0';
    }
  if (strlen(flaws_str_B)>=74)
    {
      for(i=74; flaws_str_B[i]!=' '; i--);
      strcpy(flaws_str_C,flaws_str_B+i+1);
      flaws_str_B[i]='\0';
    }
  if (res) { return(FALSE); } else { return(TRUE); }
}



void add_entry(struct mountlist_itself *mountlist, newtComponent listbox, int currline, void *keylist[])
{
  int i, num_to_add;
  newtComponent myForm, b_1, b_2, b_res, mountpointComp, label0, label1, label2, label3, sizeComp, deviceComp, formatComp;
  char drive_to_add[MAX_STR_LEN], mountpoint_str[MAX_STR_LEN], size_str[MAX_STR_LEN], *mountpoint_here, *size_here, device_str[MAX_STR_LEN], *device_here, format_str[MAX_STR_LEN], *format_here;
  strcpy(device_str,"/dev/");
  strcpy(mountpoint_str,"/");
  strcpy(format_str,"ext2");
  size_str[0]='\0';
  //  sprintf(size_str,"");
  newtOpenWindow(20,5,40,10,"Add entry");
  label0=newtLabel(2,1,"Device:    ");
  label1=newtLabel(2,2,"Mountpoint:");
  label2=newtLabel(2,3,"Size (MB): ");
  label3=newtLabel(2,4,"Format:    ");
  log_it("OK so far");
  deviceComp=newtEntry(14,1,device_str,22,&device_here,0);
  mountpointComp=newtEntry(14,2,mountpoint_str,22,&mountpoint_here,0);
  formatComp=newtEntry(14,4,format_str,10,&format_here,0);
  sizeComp=newtEntry(14,3,size_str,8,&size_here,0);
  b_1=newtButton(5,6,"  OK  ");
  b_2=newtButton(17,6,"Cancel");
  newtPushHelpLine("To add an entry to the mountlist, please fill in these fields and then hit 'OK'");
  myForm=newtForm(NULL,NULL,0);
  log_it("Hmm//");
  newtFormAddComponents(myForm,deviceComp,mountpointComp,sizeComp,formatComp,label0,label1,label2,label3,b_1,b_2,NULL);
  b_res=newtRunForm(myForm);
  strcpy(device_str,device_here);
  strcpy(mountpoint_str,mountpoint_here);
  strcpy(format_str,format_here);
  strcpy(size_str,size_here);
  strip_spaces(device_str);
  strip_spaces(mountpoint_str);
  strip_spaces(format_str);
  strip_spaces(size_str);
  newtFormDestroy(myForm);
  newtPopHelpLine();
  newtPopWindow();
  if (b_res == b_2) { return; }
  strcpy(drive_to_add,device_str);
  for(i=strlen(drive_to_add); isdigit(drive_to_add[i-1]); i--);
  num_to_add = atoi(drive_to_add+i);
  drive_to_add[i]='\0';
  currline = mountlist->entries;
  strcpy(mountlist->el[currline].device, device_str);
  strcpy(mountlist->el[currline].mountpoint, mountpoint_str);
  strcpy(mountlist->el[currline].format, format_str);
  mountlist->el[currline].size = atol(size_str)*1024;
  mountlist->entries ++;
  sort_mountlist_by_device(mountlist);
  redraw_mountlist(mountlist,keylist,listbox);
}



void edit_entry(struct mountlist_itself *mountlist, newtComponent listbox, int currline, void *keylist[])
{
  newtComponent myForm, b_1, b_2, b_res, mountpointComp, label0, label1, label2, label3, sizeComp, formatComp;
  char mountpoint_str[MAX_STR_LEN], size_str[MAX_STR_LEN], format_str[MAX_STR_LEN], *mountpoint_here, *size_here, tmp[MAX_STR_LEN], *format_here;
  strcpy(mountpoint_str,mountlist->el[currline].mountpoint);
  strcpy(format_str,mountlist->el[currline].format);
  sprintf(size_str,"%ld",mountlist->el[currline].size/1024);
  newtOpenWindow(20,5,40,10,"Edit entry");
  sprintf(tmp,"Device:     %s",mountlist->el[currline].device);
  label0=newtLabel(2,1,tmp);
  label1=newtLabel(2,2,"Mountpoint:");
  label2=newtLabel(2,3,"Size (MB): ");
  label3=newtLabel(2,4,"Format:    ");
  mountpointComp=newtEntry(14,2,mountpoint_str,22,&mountpoint_here,0);
  formatComp=newtEntry(14,4,format_str,10,&format_here,0);
  sizeComp=newtEntry(14,3,size_str,8,&size_here,0);
  b_1=newtButton(5,6,"  OK  ");
  b_2=newtButton(17,6,"Cancel");
  newtPushHelpLine("       Edit this partition's mountpoint and size, then click 'OK'.");
  myForm=newtForm(NULL,NULL,0);
  newtFormAddComponents(myForm,mountpointComp,sizeComp,formatComp,label0,label1,label2,label3,b_1,b_2,NULL);
  b_res=newtRunForm(myForm);
  strcpy(mountpoint_str, mountpoint_here);
  strcpy(format_str, format_here);
  strcpy(size_str, size_here);
  strip_spaces(mountpoint_str);
  strip_spaces(format_str);
  strip_spaces(size_str);
  newtFormDestroy(myForm);
  newtPopHelpLine();
  newtPopWindow();
  if (b_res != b_2)
    {
      strcpy(mountlist->el[currline].mountpoint,mountpoint_str);
      strcpy(mountlist->el[currline].format,format_str);
      mountlist->el[currline].size = atol(size_str)*1024;
      newtListboxSetEntry(listbox,(int)keylist[currline],mountlist_to_string(mountlist,currline));
    }
}



void delete_entry(struct mountlist_itself *mountlist, newtComponent listbox, int currline, void *keylist[])
{
  int pos;
  char tmp[MAX_STR_LEN];
  sprintf(tmp,"Delete %s - are you sure?",mountlist->el[currline].device);
  if (!ask_me_yes_or_no(tmp)) { return; }
  for(pos=currline; pos < mountlist->entries -1; pos++)
    { 
      swap_mountlist_entries(mountlist,pos,pos+1);
    }
  mountlist->el[pos].device[0]='\0';
  mountlist->el[pos].mountpoint[0]='\0';
  mountlist->entries --;
  redraw_mountlist(mountlist,keylist,listbox);
}



int edit_mountlist(struct mountlist_itself *mountlist)
{
  newtComponent myForm, bAdd, bEdit, bDelete, bOK, bCancel, b_res, partitionsListbox, headerMsg, flawsLabelA, flawsLabelB, flawsLabelC, bReload;
  void*curr_choice;
  int i, currline, finished=FALSE;
  void* keylist[ARBITRARY_MAXIMUM];
  char tmp[MAX_STR_LEN], flaws_str_A[MAX_STR_LEN], flaws_str_B[MAX_STR_LEN], flaws_str_C[MAX_STR_LEN];
  strcpy(flaws_str_A,"xxxxxxxxx");
  strcpy(flaws_str_B,"xxxxxxxxx");
  strcpy(flaws_str_C,"xxxxxxxxx");
  if (mountlist->entries > ARBITRARY_MAXIMUM)
    {
      log_to_screen("Arbitrary limits suck, man!"); 
      finish(1); 
    }
  newtPushHelpLine("   Please edit the mountlist to your satisfaction, then click OK or Cancel.");
  i=4;
  bAdd =    newtCompactButton(i,    17," Add ");
  bEdit =   newtCompactButton(i+=11,17," Edit ");
  bDelete = newtCompactButton(i+=12,17,"Delete");
  bReload = newtCompactButton(i+=12,17,"Reload");
  bCancel = newtCompactButton(i+=12,17,"Cancel");
  bOK =     newtCompactButton(i+=12,17,"  OK  ");
  sprintf(tmp,"%-24s %-24s %-8s  %s","Device","Mountpoint","Format","Size (MB)");
  headerMsg=newtLabel(2,1,tmp);
  flawsLabelA=newtLabel(2,13,flaws_str_A);
  flawsLabelB=newtLabel(2,14,flaws_str_B);
  flawsLabelC=newtLabel(2,15,flaws_str_C);
  partitionsListbox=newtListbox(2,2,10,NEWT_FLAG_SCROLL|NEWT_FLAG_RETURNEXIT);
  redraw_mountlist(mountlist,keylist,partitionsListbox);
  newtOpenWindow(1,3,77,18,"Editing mountlist");
  myForm=newtForm(NULL,NULL,0);
  newtFormAddComponents(myForm,headerMsg,partitionsListbox,flawsLabelA,flawsLabelB,flawsLabelC,bAdd,bEdit,bDelete,bReload,bCancel,bOK,NULL);
  while(!finished)
    {
      evaluate_mountlist(mountlist,flaws_str_A,flaws_str_B,flaws_str_C);
      newtLabelSetText(flawsLabelA,flaws_str_A);
      newtLabelSetText(flawsLabelB,flaws_str_B);
      newtLabelSetText(flawsLabelC,flaws_str_C);
      b_res = newtRunForm(myForm);
      if (b_res == bOK)
	{
	  if (!evaluate_mountlist(mountlist,flaws_str_A,flaws_str_B,flaws_str_C))
	    {finished=ask_me_yes_or_no("Your mountlist might not work. Continue anyway?");}
	  else
	    {finished=TRUE;}
	}
      else if (b_res == bCancel)
	{
	  finished=TRUE;
	}
      else if (b_res == bReload)
	{
	  if (ask_me_yes_or_no("Reload original mountlist?"))
	    {
	      load_mountlist(mountlist,"/tmp/mountlist.txt");
	      redraw_mountlist(mountlist,keylist,partitionsListbox);
	    }
	}
      else
	{ 
	  curr_choice = newtListboxGetCurrent(partitionsListbox);
	  for(i=0; i<mountlist->entries && keylist[i]!=curr_choice; i++);
	  if (i == mountlist->entries)
	    { log_to_screen("I don't know what that button does!"); }
	  else
	    {
	      currline=i;
	      if (b_res == bAdd) 
		{
		  add_entry(mountlist,partitionsListbox,currline,keylist);
		}
	      else if (b_res == bDelete)
		{
		  delete_entry(mountlist,partitionsListbox,currline,keylist);
		}
	      else
		{
		  edit_entry(mountlist,partitionsListbox,currline,keylist);
		}
	    }
	}
    }
  newtFormDestroy(myForm);
  newtPopWindow();
  newtPopHelpLine();
  if (b_res == bOK) { return(0); }
  else 
    {
    // popup_and_OK("You pushed 'cancel'. I shall now abort.");
    return(1); 
    }
}



newtComponent g_isoform_main=NULL, g_isoform_header, g_isoform_scale, g_isoform_timeline, g_isoform_pcline;
long g_isoform_starttime;
int g_isoform_old_progress=-1;
char g_isoform_header_str[MAX_STR_LEN];


void open_evalcall_form(char*title)
{
  char tmp[MAX_STR_LEN];
  g_isoform_old_progress=-1;
  strcpy(tmp,title);
  strcpy(g_isoform_header_str,title);
  center_string(tmp,80);
  newtPushHelpLine(tmp);
  center_string(g_isoform_header_str,36);
  g_isoform_starttime=get_time();
  g_isoform_header=newtLabel(1,1,g_isoform_header_str);
  g_isoform_scale=newtScale(3,3,34,100);
  newtOpenWindow(20,6,40,7,"Please Wait");
  g_isoform_main=newtForm(NULL,NULL,0);
  g_isoform_timeline=newtLabel(1,5,"This is the timeline");
  g_isoform_pcline=newtLabel(1,6,"This is the pcline");
  newtFormAddComponents(g_isoform_main, g_isoform_timeline, g_isoform_pcline, g_isoform_header, g_isoform_scale, NULL);
  newtRefresh();
  update_evalcall_form(0);
}



void update_evalcall_form(int curr)
{
  long current_time,time_taken,time_total_est,time_remaining;
  char timeline_str[MAX_STR_LEN], pcline_str[MAX_STR_LEN];
  int percentage;
  //  log_it("update_eval_call_form called");
  if (curr<1) {percentage=1;} else {percentage=curr;}
  current_time=get_time();
  time_taken = current_time - g_isoform_starttime;
  time_total_est = time_taken * 100L / percentage;
  time_remaining = time_total_est - time_taken;
  newtLabelSetText(g_isoform_header,g_isoform_header_str);
  if (percentage > g_isoform_old_progress)
    {
      g_isoform_old_progress=percentage;
      newtScaleSet(g_isoform_scale,percentage);
      sprintf(timeline_str,"%2ld:%02ld taken            %2ld:%02ld remaining",time_taken / 60, time_taken % 60, time_remaining / 60, time_remaining % 60);
      sprintf(pcline_str,     " %3d%% done              %3d%% to go",percentage,100-percentage);
      newtLabelSetText(g_isoform_pcline,pcline_str);
      newtLabelSetText(g_isoform_timeline,timeline_str);
    }
  newtRefresh();
  //  log_it("Back from update_evalcall_form");
}


void close_evalcall_form(void)
{
  if (g_isoform_main==NULL) { return; }
  update_evalcall_form(100);
  sleep(1);
  newtPopHelpLine();
  newtFormDestroy(g_isoform_main);
  newtPopWindow();
  g_isoform_main=NULL;
  g_isoform_old_progress=-1;
}
