/*        mondo-restore.c               Hugo Rabson                  11/14/2001

	  So far, mondo-restore.c can do:-
	  prep-me             (partition_everything, format_everything)
	  mount-me            (mount_all_devices)
	  unmount-me          (unmount_all_devices)
	  insist-on-cd        (insist_on_this_cd_number)
	  restore-me          (restore_everything)
	  compare-me          (compare_everything)
	  stablilo-me         (run_lilo) <-- which CALLS stablilo-me

11/14
- when trying to decompress, always check for presence of decompressor; abort
  if it cannot be found
- do clever one-time change to /etc/rc.local, to make sure that /tmp has the
  right permissions at boot-time

11/11
- when 'find'ing slices as part of the restore/compare loop, don't list them
  to the screen: that's just plain ugly ;)

11/10
- only run stablilo-me if in Interactive Mode (and if user wants to)
- in Interactive Mode:-
  - edit lilo.conf
  - edit fstab
  - keep editing them until LILO runs okay
- mkdir and set permissions for /mnt/RESTORING/tmp at the start _and_ at the
  end of restoring (i.e. just after mounting and just before unmounting)

11/01
- before running stablilo-me, ask the user if they modified the mountlist; if
  they have them run stablilo-me; if they haven't, just run lilo :-)
- umount /mnt/cdrom, not /dev/cdrom; I have found that /mnt/cdrom works better
  with busybox's umount command
- use mkfs -t vfat if the vfat kludge script fails on a given partition
- in compare_all_tarballs(), added an else{} after the if{}, just because it
  looks cleaner that way; also, insist on CD #n at the start of every loop
  iteration, just in case there are 'sillies' on a given CD / archive
- if Compare Mode finds differences then ask user to see /tmp/changed.txt for
  a list of changed files

10/28
- when comparing tape archives, only log to screen the lines containing errors
- delete various log files at start of cycle, just in case they were left there
  by a previous run

10/20
- if I fail to mount all devices, I'll unmount whatever I mounted before I rtn

10/11
- if suffix is .lzo then use lzop, not bzip2
- big files are always bunzip2'd, never lzop'd
- set each restored biggiefile to '+x'
- chdir /mnt/RESTORING before comparing/restoring to tape
- count afio's number of output lines when comparing; _that_ is the true
  number of diffs/errors, not the value returned by afio

10/08
- when restoring from or comparing to tape, don't update progress form unless
  some files have just been restored, or you'll screw up the time estimate

10/06
- gauge the comparison/restoration's progress by the filelist# we're on, not
  the file#; the former gives a much better indication of progress
- do a 'cd /mnt/RESTORING' before comparing tape's contents to the filesystem

10/03
- when mounting all devices, don't forget to mount and unmount swap
- improving fdisk- and mkfs-logging
- if 'fdisk -v' fails then abort without trying to do anything at all
- do not try to format partitions if the act of partitioning them failed
- added 'sync' before final umount and eject of CD-ROM; also only bother
  umounting if _not_ tape
- changed 'errors occurred during compare phase' to 'differences found...'
- if no biggiefiles in biggielist then do not even try to restore biggiefiles

09/30
- tape streamers are now supported
- blank drives using 'fputc(fout,'\0')' instead of the 'dd' command

09/28
- simplified the calls to format ext2 and ext3 filesystems; now, they use
  mkfs -t ext2 (etc.) which is more likely to work on the user's distro
- still trying to fix compare_a_biggiefile()...

09/26
- if eject or umount fails, tell the user! :-)

09/22
- adding LVM support
  - physical volumes (PV's) allocated to LVM will be partitioned at the
    same time as other, non-LVM partitions; their partition types will be set
    to '8e' (LVM).
  - at the start of 'format_everything' is a call to do_my_funky_lvm_stuff;
    this will initialize the logical volumes (LV's) present in the mountlist
  - format_everything will format the LV's as if they were nothing special;
    it ignores the PV's because they are handled by do_my_funky_lvm_stuff
  - when mounting and unmounting, ignore devices with 'lvm' mountpoints
- added code to line 1017 (approx.) to make sure that any trailing \n or \r
  is stripped from the filename of the biggiefile being restored

09/15
- improved the error-reporting; if a tarball cannot be accessed (i/o error)
  then say so; don't try & fail in an ugly way
- tried to fix the biggiefile comparison code (again)
- now supports '--edit-mountlist', which lets user edit mountlist w/o doing
  anything destructive to the hard drive partitions

09/09
- added Minix support; improved the support of unknown filesystem formats
- moved generic tools to mondo-tools.c
- fixed some compiler warnings, by #including <string.h> in my-stuff.h
- mkreiserfs ---- dropped the '-q' option cos mkreiserfs doesn't understand it
- still trying to fix compare_a_biggiefile()
- still trying to fix restore_a_biggiefile(), even though I can't make it
  go wrong; I'm just trying to make the code more like the script, which has
  been bug free (AFAIK) for about 6 months

08/28
- moved the progress form up one line
- fixed compare_a_biggiefile() so that it can handle filenames containing
  spaces
- modified restore_a_biggiefile() to use popen to write the output file;
  should get around the 'spaces in filename' problem
- Interactive Mode now calls sort_mountlist_by_mountpoint() before mounting
  the partitions; the other modes always did but I somehow neglected to make
  Interactive Mode do it; oops

08/24
- changed the nature of compare_a_biggiefile()'s call to md5sum, to use
  fopen() instead of popen()
- added sort_mountlist_by_device() and make_list_of_drives()
- built-in mountlist editor! Woohoo...
- added lots of sanity-checking to the mountlist editor
- changed lots of "64"s to "ARBITRARY_MAXIMUM"s
- changed lots of "512"s to "MAX_STR_LEN"s
- changed 'errors occurred while comparing' to 'differences found...'
- fixed a serious bug in restore_a_biggiefile() which could lock up the
  restore phase; now, biggiefiles may span CD's okay
- fixed a bug in the compare phase (compare_a_biggiefile())

08/16
- interactive_mode() did not create and set the permissions of
  /mnt/RESTORING/tmp; so, under some conditions, the user might be left
  with a /tmp directory whose permissions were wrong; FIXED (thanks, Ang Tan!)
- replaced '.tar.bz2' references with '.afio.bz2'
- when partitioning a device, log its size
- when formatting a device, log its name & format
- run 'df -m' after mounting and before unmounting, so that we can see
  exactly how big the partitions are (before data is restored) and how full
  they have gotten (after data has been restored)
- changed vacuum-packing progress-tracking kludge from 'g_maximum_progress++'
  to 'g_current_progress--', just to make the feedback a little prettier
- moved the '...ran just fine'/'...ran with errors' feedback to after the
  log output itself, in run_program_and_log_output();
- moved the 'insisting on CD#N' comment to inside the loop that actually
  _asks_ for it (i.e. if it's not there already)
- added 10-second delay before nuking

08/11
- stop saying "N files differ so far" after comparing each tarball
- moving from ncurses to newt (interface)
- when restore_a_tarball calls afio, it now will pipe its output to
  /tmp/mondo-restore.log
- if restore_a_tarball cannot access tarball N's filelist then report the
  error, return an error & don't try to extract files from that tarball
- g_maximum_progress is set to 1 if it's <=0 (open_progress_form())
- if mondo-restore is called without parameters, it will let the user
  choose between interactive, nuke and compare (and abort)

07/10 --- first incarnation
*/


#include "my-stuff.h"


#define ARCHIVES_PATH "/mnt/cdrom/archives"

// global vase - er, vars
extern long g_maximum_progress, g_current_progress, g_start_time;
extern int g_currentY, g_current_cd_number;
char g_tape_device[MAX_STR_LEN];
long g_tape_size;    // in Megabytes


// externs
extern void finish(int);
extern void setup_newt_stuff(void);
extern char which_restore_mode(void);
extern int ask_me_yes_or_no(char*);
extern void log_to_screen(char*);
extern void update_progress_form(char*);
extern void open_progress_form(char*,char*,char*,char*,long);
extern void close_progress_form(void);
extern void popup_and_OK(char*);
extern int  popup_and_get_string(char*,char*,char*);
extern long get_time(void);
extern int run_program_and_log_output(char*);
extern int is_this_device_mounted(char*);
extern int does_partition_exist(char*device,int partno);
extern int strcmp_inc_numbers(char*,char*);
extern long count_lines_in_file(char*);
extern long length_of_file(char*);
extern long noof_lines_that_match_wildcard(char*,char*);
extern char *slice_fname(long,long,bool,char*);
extern char *last_line_of_file(char*);
extern void log_file_end_to_screen(char*,char*);


/* ---------------- procs and funcs ---------------------- */
void sort_mountlist_by_device(struct mountlist_itself*);
int format_everything(struct mountlist_itself*);
int partition_device(char*,int,int,char*,long);
int which_format_command_do_i_need(char*,char*);
int format_device(char*,char*);
int load_mountlist(struct mountlist_itself*,char*);
int make_dummy_partitions(char*,int);
int interact_with_tape(char*,char,char*,char*,char*,char*,char*);
int partition_drive(struct mountlist_itself*, char*);
int extrapolate_mountlist_to_include_raid_partitions(struct mountlist_itself*, struct mountlist_itself*);
bool mountlist_contains_raid_devices(struct mountlist_itself*);
int stop_raid_device(char*);
int stop_all_raid_devices(struct mountlist_itself*);
int make_list_of_drives(struct mountlist_itself*, char drivelist[ARBITRARY_MAXIMUM][MAX_STR_LEN]);
int partition_everything(struct mountlist_itself*);
int mount_device(char*,char*,char*);
void swap_mountlist_entries(struct mountlist_itself*,int,int);
void sort_mountlist_by_mountpoint(struct mountlist_itself*,bool);
void sort_mountlist_by_device(struct mountlist_itself*);
int mount_all_devices(struct mountlist_itself*);
int unmount_all_devices(struct mountlist_itself*);
int what_number_cd_is_this(void);
int do_my_funky_lvm_stuff(struct mountlist_itself*);


/* ---------------- global vars -------------------------- */
char MONDO_LOGFILE[MAX_STR_LEN]="/tmp/mondo-restore.log";


void fatal_error(char*msg)
{
  log_to_screen(msg);
  finish(1);
}




int format_everything(struct mountlist_itself *mountlist)
{
  int res,retval=0,lino;
  char tmp[MAX_STR_LEN];
  mvaddstr_and_log_it(g_currentY,0,"Formatting partitions     ");
  open_progress_form("Formatting partitions","I am now formatting your hard disk partitions.", "This may take up to five minutes.","",mountlist->entries);
  // do my funky LVM stuff if necessary
  if (does_file_exist("/tmp/i-want-my-lvm"))
    {
      log_to_screen("I want my... I want my LVM... *cue Dire Straits*");
      res=do_my_funky_lvm_stuff(mountlist);
      retval+=res;
      if (res) { log_to_screen("do_my_funky_lvm_stuff returned errors"); }
      else { log_it("do_my_funky_lvm_stuff ran OK"); }
    }
  for(lino=0; lino < mountlist->entries; lino++)
    {
      res=format_device(mountlist->el[lino].device,mountlist->el[lino].format);
      retval+=res;
      g_current_progress++;
    }
  close_progress_form();
  if (retval)
    {
      mvaddstr_and_log_it(g_currentY++,74,"Failed.");
      log_to_screen("Errors occurred during the formatting of your hard drives.");
    }
  else
    {
      mvaddstr_and_log_it(g_currentY++,74,"Done.");
    }
  return(retval);
}


int modify_rclocal_one_time(char*path)
{
  char rclocal_fname[MAX_STR_LEN], newfile_fname[MAX_STR_LEN],
    tmp[MAX_STR_LEN];
  sprintf(rclocal_fname,"%s/rc.local",path);
  system("chmod -R 1777 /mnt/RESTORING/tmp");
  return(0); // remove this line to open the floodgates...
  if (! does_file_exist(rclocal_fname))
    {
      sprintf(rclocal_fname,"%s/rc.d/rc.local",path);
    }
  if (! does_file_exist(rclocal_fname))
    {
      return(0);
    }
  sprintf(newfile_fname,"%s/rc.local.mondorescue",path);
  sprintf(tmp,"cat %s | grep mondorescue &> /dev/null",rclocal_fname);
  if (system(tmp))
    {
      sprintf(tmp,"echo \"[ -e %s ] && %s\n\" >> %s",newfile_fname,newfile_fname,rclocal_fname);
      system(tmp);
    }
  sprintf(tmp,"echo -en \"#!/bin/sh\
\\n\
\\n\
cat %s | grep -v mondorescue > %s\\n\
chmod -R 1777 /tmp\\n\
yes | rm -f %s\\n\
\" > %s",rclocal_fname,rclocal_fname,newfile_fname,newfile_fname);
  system(tmp);
  sprintf(tmp,"chmod +x %s",newfile_fname);
  system(tmp);
  return(0);
}



int partition_device(char*drive, int partno, int prev_partno, char *format, long partsize)
{
  int errors, retval, res;
  char program[MAX_STR_LEN], devicestring[MAX_STR_LEN], logfile[MAX_STR_LEN], *p, partcode[16], tmp[MAX_STR_LEN], c;
  FILE*fout;

  sprintf(devicestring,"%s%d",drive,partno);
  sprintf(tmp,"Partitioning device %s (%ld MB)",devicestring,partsize/1024);
  update_progress_form(tmp);
  log_it(tmp);
  if (is_this_device_mounted(devicestring))
    {
      sprintf(tmp,"%s is mounted, and should not be partitioned",devicestring);
      log_to_screen(tmp);
      return(1);
    }
  else if (does_partition_exist(drive,partno))
    {
      sprintf(tmp,"%s already has a partition",devicestring);
      log_to_screen(tmp);
      return(1);
    }

  //  sprintf(tmp,"Partitioning %s  ",devicestring);
  //  mvaddstr_and_log_it(g_currentY+1,30,tmp);
  p=(char*)strrchr(devicestring,'/');
  sprintf(logfile,"/tmp/fdisk.log.%s",++p);
  sprintf(program,"fdisk %s &> %s",drive,logfile);
  fout=popen(program,"w");

  /* make it a primary/extended/logical */
  if (partno<=4)
    {
      fprintf(fout,"n\np\n%d\n",partno); 
    }
  else
    {
      if (partno==5)
	{
	  if (prev_partno >= 4)
	    {
	      log_to_screen("You need to leave at least one partition free, for 'extended/logical'");
	      return(1);
	    }
	  else
	    {
	      fprintf(fout,"n\ne\n%d\n\n\n",prev_partno+1);
	    }
	}
      fprintf(fout,"n\nl\n");
    }
  fprintf(fout,"\n");  /* start block (ENTER for next free block) */
  if (partsize>0) { fprintf(fout,"+%ld",partsize); fprintf(fout,"K\n"); }
  else            { fprintf(fout,"\n"); }

  /* set partition's format type (e.g. 82, 83, 05) */
  if (strcmp(format,"swap")==0) { strcpy(partcode,"82"); }
  else if (strcmp(format,"vfat")==0)
    {
      if (partsize/1024 > 8192) { strcpy(partcode,"c"); }
      else                      { strcpy(partcode,"b"); }
    }
  else if (strcmp(format,"ext2")==0 || strcmp(format,"reiserfs")==0 || strcmp(format,"ext3")==0 || strcmp(format,"xfs")==0 || strcmp(format,"jfs")==0)
    { strcpy(partcode,"83"); }
  else if (strcmp(format,"minix")==0)
    { strcpy(partcode,"81"); }
  else if (strcmp(format,"raid")==0)
    { strcpy(partcode,"fd"); } // raid autodetect
  else if (strcmp(format,"lvm")==0)
    { strcpy(partcode,"8e"); } // LVM physical device
  else if (format[0]=='\0')
    { partcode[0]='\0'; }
  else
    {
      sprintf(tmp,"Unknown format ('%s') - using code 83",format);
      mvaddstr_and_log_it(g_currentY++,0,tmp);
      strcpy(partcode,"83");
    }
  if (partcode[0]!='\0')
    { fprintf(fout,"t\n%d\n%s\n",partno,partcode); }

  /* write to disk; close fdisk's stream */
  fprintf(fout,"w\n\n");
  pclose(fout);

  if (!does_partition_exist(drive,partno) && partsize>0)
    {
      log_it("Vaccum-packing");
      g_current_progress--;
      res=partition_device(drive,partno,prev_partno,format,-1);
      if (res)
	{
	  sprintf(tmp,"Failed to vacuum-pack %s%d",drive,partno);
	  log_to_screen(tmp);
	  retval++;
	}
      else
	{
	  retval=0;
	}
    }
  if (does_partition_exist(drive,partno))
    {
      if (retval)
	{
	  retval=0;
	}
      sprintf(tmp,"Partitioned %s%d OK ",drive,partno);
      log_to_screen(tmp);
    }
  else
    {
      sprintf(tmp,"Failed to partition %s%d",drive,partno);
      log_to_screen(tmp);
      retval++;
    }
  /*
  log_it("------------------------start of fdisk log------------------------");
  sprintf(tmp,"cat %s >> %s",logfile,MONDO_LOGFILE);
  if (system(tmp)) { log_it("Failed to append fdisk's output to the log file"); }
  log_it("--------------------------end of fdisk log------------------------");
  */
  g_current_progress++;
  return(retval);
}



int which_format_command_do_i_need(char*format,char*program)
{
  int res=0;
  char tmp[MAX_STR_LEN];
  if (strcmp(format,"swap")==0)      
    { strcpy(program,"mkswap"); }
  else if (strcmp(format,"vfat")==0) 
    { 
      //      if (does_file_exist("/sbin/format-and-kludge-vfat"))
      //	{ 

	  strcpy(program,"format-and-kludge-vfat"); 

	  //}
	  //else
	  //{ strcpy(program,"mkfs -t vfat"); }
    }
  else if (strcmp(format,"reiserfs")==0) 
    { strcpy(program,"mkreiserfs"); }
  else if (strcmp(format,"xfs")==0)  
    { strcpy(program,"mkfs.xfs -f -q"); }
  else if (strcmp(format,"jfs")==0)  
    { strcpy(program,"mkfs.jfs"); }
  else if (strcmp(format,"ext3")==0) 
    { strcpy(program,"mkfs -t ext2 -F -j -Jsize=10 -q"); }
  else if (strcmp(format,"ext2")==0)
    { strcpy(program,"mkfs -t ext2 -F -q"); }
  else if (strcmp(format,"minix")==0)
    { strcpy(program,"mkfs.minix"); }
  else
    {
      sprintf(program,"mkfs -t %s",format);
      sprintf(tmp,"Unknown format - assuming '%s' will do",format,program);
      log_it(tmp);
      res=0;
    }
  return(res);
}



int format_device(char*device, char*format)
{
  FILE*fout;
  int res,retval=0;
  char program[MAX_STR_LEN],tmp[MAX_STR_LEN],*p;

  if (strcmp(format,"lvm")==0) // do not format LVM PV's
    {
      sprintf(tmp,"Not formatting %s (it is an LVM PV)",device);
      log_it(tmp);
      return(0);
    }
  if (is_this_device_mounted(device))
    {
      sprintf(tmp,"%s is mounted - cannot format        ",device);
      log_to_screen(tmp);
      return(1);
    }
  if (strstr(device,"/dev/md"))
    {
      sprintf(tmp,"Doing nifty pre-formatting stuff to %s",device);
      log_to_screen(tmp);
      stop_raid_device(device);
      /* format raid partition */
      sprintf(program,"mkraid --really-force %s",device);
      res=run_program_and_log_output(program);
      // retval+=res;
    }
  res=which_format_command_do_i_need(format,program);
  sprintf(tmp,"%s %s",program,device);
  if (strstr(program,"kludge")) { strcat(tmp," /"); }
  sprintf(program,"sh -c 'echo -en \"y\\ny\\ny\\n\" | %s'",tmp);
  sprintf(tmp,"Formatting %s as %s",device,format);
  update_progress_form(tmp);
  res=run_program_and_log_output(program);
  if (res && strstr(program,"kludge"))
    {
      sprintf(tmp,"Kludge failed; using regular mkfs.%s to format %s",format,device);
      sprintf(program,"mkfs -t %s -F 32 %s",format,device);
      res=run_program_and_log_output(program);
    }
  retval+=res;
  if (retval)
    {
      strcat(tmp,"...failed");
    }
  else
    {
      strcat(tmp,"...OK");
    }
  log_to_screen(tmp);
  return(retval);
}





int load_mountlist(struct mountlist_itself *mountlist, char *fname)
{
  FILE*fin;
  char incoming[MAX_STR_LEN],siz[128],c,tmp[MAX_STR_LEN];
  int items;
  fin=fopen(fname,"r");
  if (!fin)
    {
      log_to_screen("Cannot open mountlist");
      return(1);
    }
  items=0;
  fgets(incoming,MAX_STR_LEN-1,fin);
  log_it("Loading mountlist...");
  while(!feof(fin))
    {
      sscanf(incoming,"%s %s %s %s",mountlist->el[items].device, mountlist->el[items].mountpoint, mountlist->el[items].format, siz);
      //      if (!isalpha(siz[0])) {strcpy(siz,"1111");}
      mountlist->el[items].size = atol(siz);
      if (mountlist->el[items].device[0]!='\0' && mountlist->el[items].device[0]!='#')
	{
	  if (items >= ARBITRARY_MAXIMUM)
	    {
	      log_to_screen("Too many lines in mountlist.. ABORTING");
	      finish(1);
	    }
	  sprintf(tmp,"%s %s %s %ld",mountlist->el[items].device, mountlist->el[items].mountpoint, mountlist->el[items].format, mountlist->el[items].size);
	  log_it(tmp);
	  items++;
	}
      fgets(incoming,MAX_STR_LEN-1,fin);
    }
  fclose(fin);
  mountlist->entries=items;
  //  mvaddstr_and_log_it(g_currentY++,74,"Done.");
  log_it("Mountlist loaded successfully.");
  sprintf(tmp,"%d entries in mountlist",items);
  log_it(tmp);
  sort_mountlist_by_device(mountlist);
  return(0);
}



int make_dummy_partitions(char *drivename, int devno_we_must_allow_for)
{
  int current_devno, previous_devno, i, j, retval=0, res;
  char tmp[MAX_STR_LEN], device[MAX_STR_LEN];
  if (devno_we_must_allow_for >= 5)
    {
      sprintf(tmp,"Making dummy primary %s%d",drivename,1);
      log_it(tmp);
      g_maximum_progress++;
      res=partition_device(drivename,1,0,"ext2",32000);
      retval+=res;
      previous_devno=1;
      current_devno=5;
    }
  else
    {
      previous_devno=0;
      current_devno=1;
    }
  for(; current_devno < devno_we_must_allow_for; current_devno++)
    {
      sprintf(tmp,"Creating dummy partition %s%d",drivename,current_devno);
      log_it(tmp);
      g_maximum_progress++;
      res=partition_device(drivename,current_devno,previous_devno,"ext2",32000);
      retval+=res;
      previous_devno=current_devno;
    }
  return(previous_devno);
}


int zero_out_a_device(char*device)
{
  FILE*fout;
  char tmp[MAX_STR_LEN];
  int i;
  sprintf(tmp,"Zeroing drive %s",device);
  log_it(tmp);
  fout=fopen(device,"w");
  if (!fout)
    {
      log_it("Unable to open/write to device");
      return(1);
    }
  for(i=0;i<16384;i++)
    {
      fputc('\0',fout);
    }
  fclose(fout);
  log_it("Device successfully zeroed.");
  return(0);
}



int partition_drive(struct mountlist_itself *mountlist, char *drivename)
{
  int current_devno, previous_devno=0, lino, i, retval=0, res;
  long partsize;
  char devicestring[MAX_STR_LEN],format[MAX_STR_LEN],commstr[MAX_STR_LEN], tmp[MAX_STR_LEN];

  sprintf(tmp,"Partitioning drive %s",drivename);
  log_it(tmp);
  for(current_devno=1; current_devno<99; current_devno++)
    {
      sprintf(devicestring,"%s%d",drivename,current_devno);
      for(lino=0; lino < mountlist->entries && strcmp(mountlist->el[lino].device,devicestring)!=0; lino++);
      if (lino >= mountlist->entries) {continue;}
      /* OK, we've found partition /dev/hdxN in mountlist; let's prep it */
      if (!previous_devno)
	{
	  sprintf(tmp,"Wiping %s",drivename);
	  log_it(tmp);
	  if (zero_out_a_device(drivename))
	    {
	      sprintf(tmp,"Warning - unable to zero %s",drivename);
	      log_to_screen(tmp);
	    }
	  if (current_devno > 1)
	    { previous_devno=make_dummy_partitions(drivename,current_devno); }
	}
      strcpy(format,mountlist->el[lino].format);
      partsize=mountlist->el[lino].size;
      if (current_devno<=4)
	{
	  res=partition_device(drivename,current_devno,previous_devno,format,partsize);
	  retval+=res;
	}
      if (current_devno>=5)
	{
	  if (current_devno==5 && previous_devno==4) { log_to_screen("You must leave at least one partition spare as the Extended partition."); return(1); }
	  res=partition_device(drivename,current_devno,previous_devno,format,partsize);
	  retval+=res;
	}
      if (previous_devno+1 < current_devno)
	{
	  /*
	  for(i=previous_devno+1;i<current_devno;i++)
	    {
	      sprintf(tmp,"%s%d not mentioned in mountlist.",drivename,i);
	      log_to_screen(tmp);
	    }
	  */
	}
      previous_devno=current_devno;
    }
  return(retval);
}



int extrapolate_mountlist_to_include_raid_partitions(struct mountlist_itself *new_mountlist, struct mountlist_itself *old_mountlist)
{
  FILE*fin;
  int retval, lino;
  char incoming[MAX_STR_LEN],*p,tmp[MAX_STR_LEN];
  new_mountlist->entries = 0;
  for(lino=0; lino < old_mountlist->entries; lino++)
    {
      if (strstr(old_mountlist->el[lino].device,"/dev/md"))
	{
	  if (!does_file_exist("/etc/raidtab")) { log_to_screen("Cannot find /etc/raidtab - cannot extrapolate the fdisk entries"); finish(1); }
	  fin=fopen("/etc/raidtab","r");
	  if (!fin) { log_to_screen("Cannot open /etc/raidtab"); finish(1); }
	  for(fgets(incoming,MAX_STR_LEN-1,fin); !feof(fin) && !strstr(incoming,old_mountlist->el[lino].device); fgets(incoming,MAX_STR_LEN-1,fin));
	  if (!feof(fin))
	    {
	      sprintf(tmp,"Investigating %s",old_mountlist->el[lino].device);
	      log_it(tmp);
	      for(fgets(incoming,MAX_STR_LEN-1,fin); !feof(fin) && !strstr(incoming,"raiddev"); fgets(incoming,MAX_STR_LEN-1,fin))
		{
		  if (strstr(incoming,"device") && !strchr(incoming,'#'))
		    {
		      for(p=incoming+strlen(incoming); *(p-1) <= 32; p--);
		      *p='\0';
		      for(p--; p>incoming && *(p-1)>32; p--);
		      sprintf(tmp,"Extrapolating %s",p);
		      log_it(tmp);
		      strcpy(new_mountlist->el[new_mountlist->entries].device,p);
		      strcpy(new_mountlist->el[new_mountlist->entries].mountpoint,"raid");
		      strcpy(new_mountlist->el[new_mountlist->entries].format,"raid");
		      new_mountlist->el[new_mountlist->entries].size = old_mountlist->el[lino].size;
		      new_mountlist->entries++;
		    }
		}
	    }
	  fclose(fin);
	}
      else
	{
	  strcpy(new_mountlist->el[new_mountlist->entries].device, old_mountlist->el[lino].device);
	  strcpy(new_mountlist->el[new_mountlist->entries].mountpoint, old_mountlist->el[lino].mountpoint);
	  strcpy(new_mountlist->el[new_mountlist->entries].format, old_mountlist->el[lino].format);
	  new_mountlist->el[new_mountlist->entries].size = old_mountlist->el[lino].size;
	  new_mountlist->entries++;
	}
    }
}



bool mountlist_contains_raid_devices(struct mountlist_itself *mountlist)
{
  int i, matching=0;
  for(i=0; i<mountlist->entries; i++)
    {
      if (strstr(mountlist->el[i].device,"/dev/md")) { matching++; }
    }
  if (matching)
    { return(TRUE); }
  else
    { return(FALSE); }
}



int stop_raid_device(char *raid_device)
{
  int res,retval=0;
  char program[MAX_STR_LEN];
  sprintf(program,"raidstop %s",raid_device);
  res=run_program_and_log_output(program);
  retval+=res;
  return(retval);
}



int stop_all_raid_devices(struct mountlist_itself *mountlist)
{
  int retval=0, res, i;
  char incoming[MAX_STR_LEN],command[MAX_STR_LEN],dev[MAX_STR_LEN],*p,tmp[MAX_STR_LEN];
  FILE *fin;
  fin=fopen("/proc/mdstat","r");
  if (!fin) { return (1); }
  for(fgets(incoming,MAX_STR_LEN-1,fin); !feof(fin); fgets(incoming,MAX_STR_LEN-1,fin))
    {
      for(p=incoming;*p!='\0'&&(*p!='m'||*(p+1)!='d'||!isdigit(*(p+2))); p++);
      if (*p!='\0')
	{
	  sprintf(dev,"/dev/%s",p);
	  for(p=dev;*p>32;p++);
	  *p='\0';
	  res=stop_raid_device(dev);
	}
    }
  fclose(fin);
  return(retval);
}



int make_list_of_drives(struct mountlist_itself *mountlist, char drivelist[ARBITRARY_MAXIMUM][MAX_STR_LEN])
{
  int lino, noof_drives=0, i, j;
  char drive[MAX_STR_LEN], tmp[MAX_STR_LEN];
  for(lino=0; lino < mountlist->entries; lino++)
    {
      strcpy(drive,mountlist->el[lino].device);
      for(i=strlen(drive); isdigit(drive[i-1]); i--);
      drive[i]='\0';
      for(j=0; j<noof_drives && strcmp(drivelist[j],drive)!=0; j++);
      if (j==noof_drives)
	{
	  strcpy(drivelist[noof_drives++],drive);
	}
    }
  return(noof_drives);
}



int partition_everything(struct mountlist_itself *orig_mtlist)
{
  int lino, retval=0, noof_drives=0, i, j, res;
  char drivelist[ARBITRARY_MAXIMUM][MAX_STR_LEN], drive[MAX_STR_LEN], tmp[MAX_STR_LEN];
  struct mountlist_itself new_mtlist, *mountlist;

  mvaddstr_and_log_it(g_currentY,0,"Partitioning hard drives      ");
  mountlist=orig_mtlist;
  if (mountlist_contains_raid_devices(mountlist))
    {
      mountlist=&new_mtlist;
      extrapolate_mountlist_to_include_raid_partitions(mountlist,orig_mtlist);
      log_it("Mountlist, now include the partitions incorporated in RAID devices:-");
      for(i=0;i<mountlist->entries;i++)
	{ log_it(mountlist->el[i].device); }
      log_it("End of mountlist.");
      res=stop_all_raid_devices(mountlist);
    }
  open_progress_form("Partitioning devices","I am now going to partition all your drives.", "This should not take more than five minutes.","",mountlist->entries);

  noof_drives = make_list_of_drives(mountlist,drivelist);

  /* partition each drive */
  for(lino = 0; lino < noof_drives; lino++)
    {
      res=partition_drive(mountlist, drivelist[lino]);
      retval+=res;
    }
  close_progress_form();
  if (retval)
    {
      mvaddstr_and_log_it(g_currentY++,74,"Failed.");
      log_to_screen("Errors occurred during the partitioning of your hard drives.");
    }
  else
    {
      mvaddstr_and_log_it(g_currentY++,74,"Done.");
    }
  return(retval);
}




int mount_device(char*device, char*mountpoint, char*format)
{
  int res=0,i;
  char tmp[MAX_STR_LEN],command[MAX_STR_LEN],mountdir[MAX_STR_LEN];
  if (!strcmp(mountpoint,"lvm")) { return(0); }
  sprintf(tmp,"Mounting device %s   ",device);
  log_to_screen(tmp);
  if (!strcmp(mountpoint,"swap"))
    {
      sprintf(command,"swapon %s",device);
    }
  else
    {
      sprintf(mountdir,"/mnt/RESTORING%s",mountpoint);
      sprintf(command,"mkdir -p %s",mountdir);
      res+=system(command);
      sprintf(command,"mount %s -t %s %s &> /dev/null",device,format,mountdir);
    }
  res+=system(command);
  if (res)
    {
      sprintf(tmp,"Unable to mount device %s (type %s) at %s",device,format,mountdir);
      log_to_screen(tmp);
    }
  return(res);
}






void swap_mountlist_entries(struct mountlist_itself *mountlist, int a, int b)
{
  char device[MAX_STR_LEN], mountpoint[MAX_STR_LEN], format[MAX_STR_LEN];
  long size;
  strcpy(device,                     mountlist->el[a].device);
  strcpy(mountpoint,                 mountlist->el[a].mountpoint);
  strcpy(format,                     mountlist->el[a].format);
  size=                              mountlist->el[a].size;
  strcpy(mountlist->el[a].device,    mountlist->el[b].device);
  strcpy(mountlist->el[a].mountpoint,mountlist->el[b].mountpoint);
  strcpy(mountlist->el[a].format,    mountlist->el[b].format);
  mountlist->el[a].size=             mountlist->el[b].size;
  strcpy(mountlist->el[b].device,    device);
  strcpy(mountlist->el[b].mountpoint,mountpoint);
  strcpy(mountlist->el[b].format,    format);
  mountlist->el[b].size=             size;
}



void sort_mountlist_by_mountpoint(struct mountlist_itself *mountlist, bool reverse)
{
  int res,diff,lino=-999;
  char tmp[MAX_STR_LEN],find_one_greater_than[MAX_STR_LEN],find_one_less_than[MAX_STR_LEN];
  while(lino < mountlist->entries)
    {
      for(lino=1; lino < mountlist->entries; lino++)
	{
	  diff=strcmp(mountlist->el[lino-1].mountpoint,mountlist->el[lino].mountpoint);
	  if ((diff>0 && !reverse) || ((diff<0 && reverse)))
	    {
	      swap_mountlist_entries(mountlist,lino-1,lino);
	      break;
	    }
	}
    }
  /*
  for(lino=0; lino < mountlist->entries; lino++)
    {
      sprintf(tmp,"Line %d --- %s",lino,mountlist->el[lino].mountpoint);
      mvaddstr_and_log_it(g_currentY++,0,tmp);
    }
  */
}





void sort_mountlist_by_device(struct mountlist_itself *mountlist)
{
  int res,diff,lino=-999;
  char tmp[MAX_STR_LEN],find_one_greater_than[MAX_STR_LEN],find_one_less_than[MAX_STR_LEN];
  while (lino < mountlist->entries)
    {
      for(lino=1; lino < mountlist->entries; lino++)
	{
	  diff=strcmp_inc_numbers(mountlist->el[lino-1].device,mountlist->el[lino].device);
	  if (diff>0)
	    {
	      swap_mountlist_entries(mountlist,lino-1,lino);
	      break;
	    }
	}
    }
}



int mount_all_devices(struct mountlist_itself *mountlist)
{
  int retval=0,lino,res;
  char tmp[MAX_STR_LEN];
  mvaddstr_and_log_it(g_currentY,0,"Mounting devices         ");
  open_progress_form("Mounting devices","I am now mounting all the drives.","This should not take long.","",mountlist->entries);
  for(lino=0; lino < mountlist->entries; lino++)
    {
      if (is_this_device_mounted(mountlist->el[lino].device))
	{
	  sprintf(tmp,"%s is already mounted",mountlist->el[lino].device);
	  log_to_screen(tmp);
	}
      else if (strcmp(mountlist->el[lino].mountpoint,"lvm"))
	{
	  sprintf(tmp,"Mounting %s",mountlist->el[lino].device);
	  update_progress_form(tmp);
	  res=mount_device(mountlist->el[lino].device, mountlist->el[lino].mountpoint, mountlist->el[lino].format);
	  retval+=res;
	}
      g_current_progress++;
    }
  close_progress_form();
  if (retval) { 
    mvaddstr_and_log_it(g_currentY++,74,"Failed."); 
    log_to_screen("Unable to mount some or all of your partitions.");
  }
  else        { mvaddstr_and_log_it(g_currentY++,74,"Done."); }
  run_program_and_log_output("df -m");
  return(retval);
}



int unmount_all_devices(struct mountlist_itself *mountlist)
{
  int retval=0,lino,res;
  char command[MAX_STR_LEN],tmp[MAX_STR_LEN];
  run_program_and_log_output("df -m");
  mvaddstr_and_log_it(g_currentY,0,"Unmounting devices      ");
  open_progress_form("Unmounting devices","Unmounting all devices that were mounted," , "in preparation for the post-restoration reboot.","",mountlist->entries);
  for(lino=mountlist->entries-1;lino>=0;lino--)
    {
      if (!strcmp(mountlist->el[lino].mountpoint,"lvm")) {continue;}
      sprintf(tmp,"Unmounting device %s  ",mountlist->el[lino].device);
      log_to_screen(tmp);
      update_progress_form(tmp);
      if (!strcmp(mountlist->el[lino].mountpoint,"swap"))
	{
	  sprintf(command,"swapoff %s",mountlist->el[lino].device);
	  res=system(command);
	}
else
	{
	  sprintf(command,"umount %s",mountlist->el[lino].device);
	  res=system(command);
	}
      g_current_progress++;
      if (res)
	{
	  sprintf(tmp,"Unable to unmount device %s",mountlist->el[lino].device);
	  log_to_screen(tmp);
	}
    }
  close_progress_form();
  if (retval) { mvaddstr_and_log_it(g_currentY++,74,"Failed."); }
  else        { mvaddstr_and_log_it(g_currentY++,74,"Done."); }
  if (retval)
    {
      log_to_screen("Unable to unmount some or all of your partitions.");
    }
  return(retval);
}


/*            MONDO - saving your a$$ since Feb 18th, 2000            */


int what_number_cd_is_this()
{
  FILE*fin;
  char incoming[MAX_STR_LEN],cd_number=-1;
  if (! is_this_device_mounted("/dev/cdrom"))
    {
      system("mount /dev/cdrom -t iso9660 -o ro /mnt/cdrom &> /dev/null");
    }
  fin=fopen("/mnt/cdrom/archives/THIS-CD-NUMBER","r");
  if (fin)
    {
      fgets(incoming,MAX_STR_LEN-1,fin);
      cd_number=atoi(incoming);
      fclose(fin);
    }
  return(cd_number);
}







int run_lilo(bool offer_to_run_stablilo)
{
  char command[MAX_STR_LEN],incoming[MAX_STR_LEN];
  int res,done;
  FILE*fin;

  if (offer_to_run_stablilo && ask_me_yes_or_no("Did you change the mountlist?"))

/* interactive mode */
    {
      mvaddstr_and_log_it(g_currentY,0,"Modifying fstab and lilo.conf, and running LILO...                             ");
      sprintf(command,"stablilo-me");
      res=run_program_and_log_output(command);
      popup_and_OK("You will now edit fstab and lilo.conf");
      for(done=FALSE;!done;)
	{
	  newtFinished();
	  system("vi /mnt/RESTORING/etc/fstab");
	  system("vi /mnt/RESTORING/etc/lilo.conf");
	  newtInit();
	  newtCls();
	  if (ask_me_yes_or_no("Edit them again?")) {continue;}
	  res = run_program_and_log_output("lilo -L -r /mnt/RESTORING");
	  if (res) {res=run_program_and_log_output("lilo -r /mnt/RESTORING");}
	  if (res)
	    {
	      done = ask_me_yes_or_no("LILO failed. Re-edit system files?");
	    }
	  else
	    {
	      done = TRUE;
	    }
	}
    }
  else

/* nuke mode */
    {
      mvaddstr_and_log_it(g_currentY,0,"Running LILO...                                                 ");
      sprintf(command,"lilo -L -r /mnt/RESTORING");
      res = run_program_and_log_output(command);
      if (res) { res=run_program_and_log_output("lilo -r /mnt/RESTORING"); }
    }
  if (res)
    {
      mvaddstr_and_log_it(g_currentY++,74,"Failed.");
      log_to_screen("Failed to re-jig fstab and/or lilo. Edit/run manually, please.");
    }
  else
    {  
      mvaddstr_and_log_it(g_currentY++,74,"Done.");
    }
  return(res);
}




int restore_a_tarball(char *tarball_fname, int current_tarball_number, char*wildcard)
{
  int retval=0,res;
  long noof_lines, noof_matches;
  char command[MAX_STR_LEN],tmp[MAX_STR_LEN],incoming[MAX_STR_LEN],filelist_name[MAX_STR_LEN],c, executable[MAX_STR_LEN];
  FILE*fin;

  sprintf(filelist_name,"/mnt/cdrom/archives/filelist.%d",current_tarball_number);
  if (count_lines_in_file(filelist_name)<=0 || length_of_file(tarball_fname)<=0)
    {
      sprintf(tmp,"Unable to restore tarball %d (CD I/O error)",current_tarball_number);
      log_to_screen(tmp);
      return(1);
    }
  if (wildcard[0]=='\0') { noof_lines=count_lines_in_file(filelist_name); }
  else                   { noof_lines=noof_lines_that_match_wildcard(filelist_name,wildcard); }
  sprintf(tmp,"There are %ld interesting lines in filelist #%d   ",noof_lines,current_tarball_number);
  if (strstr(tarball_fname,".bz2"))
    { strcpy(executable,"bzip2"); }
  else
    { strcpy(executable,"lzop"); }
  sprintf(tmp,"which %s &> /dev/null",executable);
  if (system(tmp))
    { log_to_screen("compression program not found - oh no!"); finish(1); }
  if (wildcard[0]!='\0') { sprintf(command,"afio -i -M 8m -P %s -Z -y %s\\* %s",executable,wildcard,tarball_fname); }
  else                   { sprintf(command,"afio -i -M 8m -P %s -Z %s",executable,tarball_fname); }
  if (noof_lines>0)
    {
      if (wildcard[0]!='\0') { log_it(tmp); }
      res=run_program_and_log_output(command);
      retval+=res;
    }
  if (retval)
    {
      sprintf(tmp,"Errors occurred while processing tarball # %d",current_tarball_number);
      log_to_screen(tmp);
    }
  //  g_current_progress += noof_lines;
  return(retval);
}






int restore_all_tarballs(char *wildcard)
{
  int retval=0,res;
  int current_tarball_number=0;
  long max_val;
  char tmp[MAX_STR_LEN],tarball_fname[MAX_STR_LEN];

  mvaddstr_and_log_it(g_currentY,0,"Restoring from archives");
  max_val=atol(last_line_of_file("/mnt/cdrom/LAST-FILELIST-NUMBER"))+1;
  open_progress_form("Restoring from archives","Restoring data from the archives." , "Please wait. This may take some time.","",max_val);
  sprintf(tmp,"Restoring from CD #%d ",g_current_cd_number);
  log_to_screen(tmp);
  for(;;)
    {
      sprintf(tmp,"Restoring tarball # %d",current_tarball_number);
      update_progress_form(tmp);
      sprintf(tarball_fname,"/mnt/cdrom/archives/%d.afio.bz2",current_tarball_number);
      if (!does_file_exist(tarball_fname)) {sprintf(tarball_fname,"/mnt/cdrom/archives/%d.afio.lzo",current_tarball_number);}
      if (!does_file_exist(tarball_fname))
	{
	  if (!does_file_exist("/mnt/cdrom/archives/NOT-THE-LAST") || system("find /mnt/cdrom/archives/slice* &> /dev/null")==0)
	    {
	      break;
	    }
	  g_current_cd_number++;
	  sprintf(tmp,"Restoring from CD #%d",g_current_cd_number);
	  log_to_screen(tmp);
	}
      insist_on_this_cd_number(g_current_cd_number);
      res=restore_a_tarball(tarball_fname,current_tarball_number,wildcard);
      retval+=res;
      g_current_progress++;
      current_tarball_number++;
    }
  close_progress_form();
  if (retval)
    { mvaddstr_and_log_it(g_currentY++,74,"Errors."); }
  else
    { mvaddstr_and_log_it(g_currentY++,74,"Done."); }
  return(retval);
}






int restore_a_biggiefile(long bigfileno, char*wildcard)
{
  FILE*fin,*fout,*fbzip2;
  char checksum[MAX_STR_LEN],orig_cksum[MAX_STR_LEN],outfile_fname[MAX_STR_LEN],tmp[MAX_STR_LEN],command[MAX_STR_LEN],*p,bigblk[16384];
  int i,res,retval=0,percentage,finished=FALSE;
  long sliceno, noof_slices, siz;
  fin=fopen(slice_fname(bigfileno,0,FALSE,ARCHIVES_PATH),"r");
  if (!fin) {log_to_screen("Cannot even open bigfile's info file");return(1);}
  fgets(checksum,MAX_STR_LEN-1,fin);
  fclose(fin);
  p=(char*)strchr(checksum,'\t');
  if (!p)
    {sprintf(tmp,"Cannot restore bigfile %ld: no checksum!",bigfileno);log_to_screen(tmp);return(1);}
  *p='\0';
  sprintf(outfile_fname,"/mnt/RESTORING/%s",p+1);
  p=(char*)strchr(outfile_fname,'\t');
  if (p) {*p='\0';}
  for(i=strlen(outfile_fname); i>0 && outfile_fname[i-1]<32; i--);
  outfile_fname[i]='\0';
  /* skip file if we have a wildcard & it doesn't match */
  if (wildcard[0]!='\0' && !strstr(outfile_fname,wildcard))
    {
      sprintf(tmp,"Skipping %s (name doesn't match wildcard)",outfile_fname);
      return(0);
    }
  /* otherwise, continue */
  sprintf(tmp,"Reassembling big file %ld (%s)",bigfileno+1,outfile_fname);
  log_it(tmp);
  sprintf(command,"mkdir -p \"%s\" &> /dev/null",outfile_fname);
  system(command);
  sprintf(command,"rmdir \"%s\" &> /dev/null",outfile_fname);
  system(command);
  // last slice is zero-length and uncompressed; when we find it, we stop
  // We DON'T wait until there are no more slices; if we did that,
  // We might stop at end of CD, not at last slice (which is 0-len and uncompd)
  fout=fopen(outfile_fname,"w");
  for(sliceno=1,finished=FALSE; !finished; )
    {
      if (!does_file_exist(slice_fname(bigfileno,sliceno,FALSE,ARCHIVES_PATH)) && !does_file_exist(slice_fname(bigfileno,sliceno,TRUE,ARCHIVES_PATH)))
	{
	  sprintf(tmp,"Asking for CD #%d so that I may read slice #%ld\n",g_current_cd_number,sliceno);
	  log_it(tmp);
	  insist_on_this_cd_number(++g_current_cd_number); 
	}
      else if (does_file_exist(slice_fname(bigfileno,sliceno,FALSE,ARCHIVES_PATH)))
        {
	  // log_it("The end... my only friend, the end..(of this bigfile)");
	  sprintf(tmp,"End of bigfile # %ld\n",bigfileno); log_it(tmp);
	  finished=TRUE;
	}
      else
	{
	  if (!does_file_exist(slice_fname(bigfileno,sliceno,TRUE,ARCHIVES_PATH)))
	    { log_it("OK, that's pretty fscktarded"); }
	  sprintf(tmp,"Restoring slice %ld of biggiefile %ld\n",sliceno,bigfileno);
	  log_it(tmp);
          sprintf(command,"bunzip2 -c %s",slice_fname(bigfileno,sliceno,TRUE,ARCHIVES_PATH));
	  fbzip2=popen(command,"r");
	  while(!feof(fbzip2))
	    {
	      siz=fread(bigblk,1,16384,fbzip2);
	      if (siz>0) { fwrite(bigblk,siz,1,fout); }
	    }
	  pclose(fbzip2);
          sliceno++;
        }
    }
  fclose(fout);
  sprintf(tmp,"chmod +x %s",outfile_fname);
  system(tmp);
  /*
  retval+=compare_a_biggiefile(bigfileno);
  if (retval)
    {
      sprintf(tmp,"Failed to restore bigfile #%ld properly",bigfileno);
      log_to_screen(tmp);
    }
  */
  return(retval);
}


#define BIGGIELIST "/mnt/cdrom/archives/biggielist.txt"


int restore_all_biggiefiles(char *wildcard)
{
  int retval=0,res;
  long noof_biggiefiles,bigfileno=0,r;
  char tmp[MAX_STR_LEN],finished;

  sprintf(tmp,"Reassembling large files      ");
  mvaddstr_and_log_it(g_currentY,0,tmp);
  if (length_of_file(BIGGIELIST) < 6)
    {log_it("OK, no biggielist; not restoring biggiefiles");return(0);}
  noof_biggiefiles=count_lines_in_file(BIGGIELIST);
  if (noof_biggiefiles<=0)
    {log_it("OK, no biggiefiles in biggielist; not restoring biggiefiles");return(0);}
  sprintf(tmp,"OK, there are %ld biggiefiles in the archives",noof_biggiefiles);
  log_it(tmp);
  open_progress_form("Reassembling large files","I am now reassembling all the large files." , "Please wait. This may take some time.","",noof_biggiefiles);
  for(bigfileno=0,finished=FALSE;!finished;)
    {
      sprintf(tmp,"About to think about restoring bigfile %ld",bigfileno);
      log_it(tmp);
      if (!does_file_exist(slice_fname(bigfileno,0,FALSE,ARCHIVES_PATH)))
	{
	  log_it("...but its first slice isn't on this CD.");
	  if (does_file_exist("/mnt/cdrom/archives/NOT-THE-LAST"))
	    { insist_on_this_cd_number(++g_current_cd_number); }
	  else
	    { log_it("I'm going to stop restoring bigfiles."); finished=TRUE; }
	}
      else
	{
	  sprintf(tmp,"Restoring big file %ld (of %ld)",bigfileno,noof_biggiefiles);
	  update_progress_form(tmp);
	  res=restore_a_biggiefile(bigfileno,wildcard);
	  retval+=res;
	  g_current_progress++;
	  bigfileno++;
	}
    }
  if (bigfileno < noof_biggiefiles)
    { sprintf(tmp,"Warning - bigfileno=%ld but noof_biggiefiles=%ld\n",bigfileno,noof_biggiefiles); }
  else
    { log_it("All biggiefiles restored. None was left behind."); }
  close_progress_form();
  if (retval)
    { mvaddstr_and_log_it(g_currentY++,74,"Errors."); }
  else
    { mvaddstr_and_log_it(g_currentY++,74,"Done."); }
  return(retval);
}



int compare_to_tape(char*wildcard)
{
  int res;
  chdir("/mnt/RESTORING");
  res=interact_with_tape(wildcard, 'C', "-r", "Comparing filesystem", "I am comparing your filesystem against the tape.", "Please wait. This may take a couple of hours.","afio: ");
  return(res);
}


int restore_from_tape(char*wildcard)
{
  int res;
  chdir("/mnt/RESTORING");
  res=interact_with_tape(wildcard, 'R', "-i", "Restoring filesystem", "I am restoring your filesystem from tape.", "Please wait. This may take a couple of hours.","");
  return(res);
}


int interact_with_tape(char*wildcard, char todo, char *switch_to_use, char *what_i_am_doing_1, char*what_i_am_doing_2, char*what_i_am_doing_3,char*grep_screen_output)
{
  char tmp[MAX_STR_LEN], command[MAX_STR_LEN], filelist_fname[MAX_STR_LEN],
    incoming[MAX_STR_LEN], stdout_fname[MAX_STR_LEN],
    lockfile[MAX_STR_LEN], pause_for_tape_script[MAX_STR_LEN],
    wildcard_switch[MAX_STR_LEN],
    pause_for_tape_lkfile[MAX_STR_LEN],
    executable[MAX_STR_LEN];
  int i, curr_tape_no=1;
  long total_noof_files, latest_lines=0;

  if (todo!='C' && todo!='R') {fatal_error("Todo must be C or R");}
  if (wildcard[0]!='\0')
    { sprintf(wildcard_switch,"-y %s\\*",wildcard); }
  else
    { wildcard_switch[0]='\0'; }
  strcpy(tmp,last_line_of_file("/tmp/FILES-IN-FILELIST"));
  total_noof_files=atol(tmp)+100; // +100, just to make the screen look nicer
  sprintf(tmp,"total_noof_files = %ld",total_noof_files);
  log_it(tmp);
  open_progress_form(what_i_am_doing_1, what_i_am_doing_2, what_i_am_doing_3,  "", total_noof_files);
  sprintf(lockfile, "/tmp/tony-blair-is-mojo-jojo");
  sprintf(stdout_fname, "/tmp/stdout.txt");
  sprintf(pause_for_tape_script, "/mondo/pause-for-next-tape");
  unlink(lockfile);
  unlink(stdout_fname);
  if (!does_file_exist(pause_for_tape_script))
    { sprintf(pause_for_tape_script, "/usr/share/mondo/pause-for-next-tape"); }
  if (!does_file_exist(pause_for_tape_script))
    { fatal_error("pause_for_tape_script pause script does not exist"); }
  sprintf(pause_for_tape_lkfile, "/tmp/mojo-jojo-pauses-for-next-tape");
  if (does_file_exist("/tmp/USING-LZO")) 
    { strcpy(executable,"lzop"); }
  else
    { strcpy(executable,"bzip2"); }
  sprintf(tmp,"which %s &> /dev/null",executable);
  if (system(tmp))
    { log_to_screen("compression program not found - oh no!"); finish(1); }
  sprintf(command,"sh -c \"echo hi > %s; afio -v %s -f -b 10k -M 6m -c 1024 -Z -P %s -s %ldm %s -H %s %s &> %s; rm -f %s\" &", lockfile, switch_to_use, executable, g_tape_size, wildcard_switch, pause_for_tape_script, g_tape_device, stdout_fname, lockfile);
  sprintf(tmp,"Calling '%s' to access tape",command);
  log_it(tmp);
  if (system(command)) { log_to_screen("Failed to execute afio; cannot access tape."); return(1); }
  sleep(1);
  update_progress_form("Accessing tape...");
  while(does_file_exist(lockfile))
    {
      log_file_end_to_screen(stdout_fname,grep_screen_output);
      sleep(2);
      latest_lines = count_lines_in_file(stdout_fname);
      if (latest_lines > g_maximum_progress)
	{
	  latest_lines = g_maximum_progress;
	}
      if (latest_lines > g_current_progress)
	{
	  g_current_progress = latest_lines;
	  sprintf(tmp,"%ld files have been processed. Reading tape #%d...",g_current_progress,curr_tape_no);
	  update_progress_form(tmp);
	}
      if (does_file_exist(pause_for_tape_lkfile))
	{
	  system("sync");
	  sleep(2);
	  curr_tape_no++;
	  sprintf(tmp,"Please insert tape #%d and press ENTER to continue.",curr_tape_no);
	  popup_and_OK(tmp);
	  unlink(pause_for_tape_lkfile);
	  sprintf(tmp,"echo 'Accessing tape %d...' >> %s", curr_tape_no, stdout_fname);
	  system(tmp);
	}
    }
  close_progress_form();
  return(0);
}



int restore_everything(char *wc)
{
  int resA, resB, i;
  char wildcard[MAX_STR_LEN], cwd[MAX_STR_LEN], tmp[MAX_STR_LEN], newpath[MAX_STR_LEN];
  g_current_cd_number=1;
  if (wildcard[0]=='/') { strcpy(wildcard,wc+1); }
  else                  { strcpy(wildcard,wc); }
  getcwd(cwd);
  chdir("/mnt/RESTORING");
  getcwd(newpath);
  if (does_file_exist("/tmp/TAPEDEV-LIVES-HERE"))
    {
      resA=restore_from_tape(wildcard);
      resB=0;
    }
  else
    {
      resA=restore_all_tarballs(wildcard);
      resB=restore_all_biggiefiles(wildcard);
    }
  chdir(cwd);
  if (resA+resB)
    {
      log_to_screen("Errors occurred while data was being restored.");
    }
  if (length_of_file("/etc/raidtab") > 0)
    {
      log_it("Copying local raidtab to restored filesystem");
      system("cp -f /etc/raidtab /mnt/RESTORING/etc/raidtab");
    }
  return(resA+resB);
}




int compare_all_tarballs()
{
  int retval=0,res;
  int current_tarball_number=0;
  char tmp[MAX_STR_LEN],tarball_fname[MAX_STR_LEN];
  long max_val;
  mvaddstr_and_log_it(g_currentY,0,"Comparing archives");
  max_val=atol(last_line_of_file("/mnt/cdrom/LAST-FILELIST-NUMBER"))+1;
  open_progress_form("Comparing files","Comparing tarballs against filesystem.","Please wait. This may take some time.",tmp,max_val);
  sprintf(tmp,"Comparing with CD %#d ",g_current_cd_number);
  log_to_screen(tmp);
  for(;;)
    {
      insist_on_this_cd_number(g_current_cd_number);
      update_progress_form(tmp);
      sprintf(tarball_fname,"/mnt/cdrom/archives/%d.afio.bz2",current_tarball_number);
      if (!does_file_exist(tarball_fname)) {sprintf(tarball_fname,"/mnt/cdrom/archives/%d.afio.lzo",current_tarball_number);}
      if (!does_file_exist(tarball_fname))
	{
	  if (!does_file_exist("/mnt/cdrom/archives/NOT-THE-LAST") || system("find /mnt/cdrom/archives/slice* &> /dev/null")==0)
	    {
	      log_it("OK, I think I'm done with tarballs...");
	      break;
	    }
	  log_it("OK, I think it's time for another CD...");
	  g_current_cd_number++;
	  sprintf(tmp,"Comparing with CD #%d ",g_current_cd_number);
	  log_to_screen(tmp);
	}
      else
	{
	  res=compare_a_tarball(tarball_fname,current_tarball_number);
	  retval+=res;
	  g_current_progress++;
	  current_tarball_number++;
	}
    }
  close_progress_form();
  if (retval)
    { mvaddstr_and_log_it(g_currentY++,74,"Errors."); }
  else
    { mvaddstr_and_log_it(g_currentY++,74,"Done."); }
  return(retval);
}



int compare_a_tarball(char *tarball_fname, int current_tarball_number)
{
  int retval=0,res;
  long noof_lines, afio_errors;
  char command[MAX_STR_LEN],tmp[MAX_STR_LEN],incoming[MAX_STR_LEN],filelist_name[MAX_STR_LEN],c,logfile[MAX_STR_LEN], executable[MAX_STR_LEN];
  FILE*fin;

  log_it("compare_a_tarball --- starting");
  sprintf(logfile,"/tmp/afio.log.%d",current_tarball_number);
  sprintf(tmp,"logfile = %s",logfile);
  log_it(tmp);
  sprintf(filelist_name,"/mnt/cdrom/archives/filelist.%d",current_tarball_number);
  noof_lines=count_lines_in_file(filelist_name);
  sprintf(tmp,"There are %ld interesting lines in filelist #%d     ",noof_lines,current_tarball_number);
  log_it(tmp);
  if (strstr(tarball_fname,".bz2"))
    { strcpy(executable,"bzip2"); }
  else
    { strcpy(executable,"lzop"); }
  sprintf(tmp,"which %s &> /dev/null",executable);
  if (system(tmp))
    {
      log_to_screen("compression program not found - oh no!"); finish(1);
    }
  sprintf(command,"afio -r -P %s -Z %s &> %s",executable,tarball_fname,logfile);
  sprintf(tmp,"command = %s",command);
  log_it(tmp);
  res=system(command);
  retval+=res;
  if (res) {log_it("Warning - afio returned an error");}
  sprintf(command,"cat %s | sed s/': \\\"'/\\|/ | sed s/'\\\": '/\\|/ | cut -d'|' -f2 | sort | uniq >> /tmp/changed.txt",logfile);
  //  sprintf(tmp,"command = %s",command);
  //  log_it(tmp);
  system(command);
  log_it("Counting afio_errors");
  if (length_of_file(logfile)>5)
    { afio_errors=count_lines_in_file(logfile); }
  else
    { afio_errors=0; }
  sprintf(tmp,"%ld differences in tarball # %d          ",afio_errors,current_tarball_number);
  log_it(tmp);
  if (afio_errors>0)
    {
      sprintf(tmp,"Differences found while processing tarball # %d       ",current_tarball_number);
      log_to_screen(tmp);
    }
  sprintf(tmp,"%ld files differ, so far",count_lines_in_file("/tmp/changed.txt"));
  log_it(tmp);
  unlink(logfile);
  log_it("compare_a_tarball --- leaving");
  return(retval);
}




int compare_a_biggiefile(long bigfileno)
{
  FILE*fin,*fout;
  char checksum[MAX_STR_LEN],original_cksum[MAX_STR_LEN],bigfile_fname[MAX_STR_LEN],tmp[MAX_STR_LEN],command[MAX_STR_LEN],*p,*q;
  int i,res,retval=0;
  if (!does_file_exist(slice_fname(bigfileno,0,FALSE,ARCHIVES_PATH)))
    {
      if (does_file_exist("/mnt/cdrom/archives/NOT-THE-LAST"))
	{ insist_on_this_cd_number((++g_current_cd_number)); }
      else
	{
	  sprintf(tmp,"No CD's left. No biggiefiles left. No prob, Bob.");
	  log_it(tmp);
	  return(0);
	}
    }
  fin=fopen(slice_fname(bigfileno,0,FALSE,ARCHIVES_PATH),"r");
  if (!fin)
    {
      sprintf(tmp,"Cannot open bigfile %d's info file",bigfileno);
      log_to_screen(tmp);
      return(1);
    }
  fgets(checksum,MAX_STR_LEN-1,fin);
  fclose(fin);
  for(i=strlen(checksum); i>0 && checksum[i-1]<32; i--);
  checksum[i]='\0';
  p=strchr(checksum,'\t');
  if (!p) {log_to_screen("No fname present in checksum data file");finish(1);}
  *p='\0';
  p++;
  strcpy(bigfile_fname,p);
  sprintf(tmp,"fname(%ld)='%s'",bigfileno,bigfile_fname);
  log_it(tmp);
  sprintf(tmp,"Archived checksum='%s'",checksum);
  log_it(tmp);
  sprintf(command,"md5sum \"/mnt/RESTORING%s\" > /tmp/md5sum.txt 2> /tmp/errors.txt",bigfile_fname);
  log_it(command);
  system("cat /tmp/errors >> /tmp/mondo-restore.log 2> /dev/null");
  if (system(command))
    {
      log_it("Warning - command failed");
      original_cksum[0]='\0';
      return(1);
    }
  else
    {
      fin=fopen("/tmp/md5sum.txt","r");
      if (!fin)
	{ 
	  log_it("Unable to open /tmp/md5sum.txt; can't get live checksum");
	  original_cksum[0]='\0';
	  return(1);
	}
      else
	{
	  fgets(original_cksum,MAX_STR_LEN-1,fin);
	  fclose(fin);
	  for(i=strlen(original_cksum); i>0 && original_cksum[i-1]<32; i--);
	  original_cksum[i]='\0';
	  p=(char*)strchr(original_cksum,' ');
	  if (p) { *p='\0'; }
	  sprintf(tmp,"Restored checksum='%s'",original_cksum);
	  log_it(tmp);
	}
    }
  if (!strcmp(checksum,original_cksum)!=0)
    { log_it("MATCH :-)"); }
  else
    { log_it("...not the same"); retval++; }
  if (retval)
    {
      fout=fopen("/tmp/changed.txt","a");
      fprintf(fout,"%s\n",bigfile_fname);
      fclose(fout);
      sprintf(tmp,"%s does not match\n",bigfile_fname);
      log_it(tmp);
    }
  return(retval);
}



int compare_all_biggiefiles()
{
  int retval=0,res;
  long noof_biggiefiles,bigfileno=0,r;
  char tmp[MAX_STR_LEN];

  log_it("Comparing biggiefiles");
 
  if (length_of_file(BIGGIELIST)<6)
    { log_it("OK, really teeny-tiny biggielist; not comparing biggiefiles"); return(0); }
  noof_biggiefiles=count_lines_in_file(BIGGIELIST);
  if (noof_biggiefiles<=0)
    {log_it("OK, no biggiefiles; not comparing biggiefiles");return(0);}
  mvaddstr_and_log_it(g_currentY,0,"Comparing large files                                                  ");
  open_progress_form("Comparing large files","I am now comparing the large files" , "against the filesystem. Please wait.","",noof_biggiefiles);
  for(bigfileno=0;bigfileno<noof_biggiefiles;bigfileno++)
    {
      sprintf(tmp,"Comparing big file #%d",bigfileno);
      log_it(tmp);
      update_progress_form(tmp);
      res=compare_a_biggiefile(bigfileno);
      retval+=res;
      g_current_progress++;
    }
  close_progress_form();
  if (retval)
    { mvaddstr_and_log_it(g_currentY++,74,"Errors."); }
  else
    { mvaddstr_and_log_it(g_currentY++,74,"Done."); }
  return(retval);
}



int compare_everything()
{
  char tmp[MAX_STR_LEN],cwd[MAX_STR_LEN],new[MAX_STR_LEN],command[MAX_STR_LEN];
  int resA=0,resB=0;
  long noof_changed_files;

  getcwd(cwd);
  chdir("/mnt/RESTORING");
  getcwd(new);
  sprintf(tmp,"new path is %s",new);
  g_current_cd_number=1;
  insist_on_this_cd_number(g_current_cd_number);
  unlink("/tmp/changed.txt");
  resA=compare_all_tarballs();
  resB=compare_all_biggiefiles();
  chdir(cwd);
  noof_changed_files=count_lines_in_file("/tmp/changed.txt");
  if (noof_changed_files)
    {
      sprintf(tmp,"%ld files do not match the backup            ",noof_changed_files);
      mvaddstr_and_log_it(g_currentY++,0,tmp);
      sprintf(command,"cat /tmp/changed.txt >> %s",MONDO_LOGFILE);
      system(command);
    }
  else
    {
      sprintf(tmp,"All files match the backup                     ");
      mvaddstr_and_log_it(g_currentY++,0,tmp);
    }
  if (resA+resB)
    {
      log_to_screen("Differences found while files were being compared.");
    }
  return(resA+resB);
}




int nuke_mode(struct mountlist_itself *mountlist)
{
  int retval=0,res,i;
  char tmp[MAX_STR_LEN];
  open_progress_form("CAUTION","Be advised: I am about to erase your hard disk(s).","You may push 'reset' to abort safely.","",10);
  for(i=0;i<10;i++)
    {
      g_current_progress=i;
      sprintf(tmp,"You have %d seconds left to abort.",10-i);
      update_progress_form(tmp);
      sleep(1);
    }
  close_progress_form();
  mvaddstr_and_log_it(1,30,"Restoring Automatically");
  res=partition_everything(mountlist);
  retval+=res;
  if (!res)
    {
      res+=format_everything(mountlist); 
    }
  retval+=res;
  if (res) { mvaddstr_and_log_it(g_currentY++,0,"Failed to partition and/or format your hard drives."); return(retval); }
  sort_mountlist_by_mountpoint(mountlist,0);
  retval+=mount_all_devices(mountlist);
  system("mkdir -p -m 1777 /mnt/RESTORING/tmp");
  if (retval) { unmount_all_devices(mountlist); return(retval);}
  retval+=restore_everything("");
  retval+=run_lilo(FALSE);
  modify_rclocal_one_time("/mnt/RESTORING/etc");
  retval+=unmount_all_devices(mountlist);
  res=run_program_and_log_output("label-partitions-as-necessary /tmp/mountlist.txt < /tmp/fstab");
  if(res) { log_to_screen("label-partitions-as-necessary returned an error"); }
  retval+=res;
  if (retval) {log_to_screen("Errors occurred during the nuke phase.");}
  return(retval);
}




int interactive_mode(struct mountlist_itself *mountlist, bool destructive_mode)
{
  int retval=0,res,ptn_errs=0,fmt_errs=0,i;
  char c,tmp[MAX_STR_LEN],wildcard[MAX_STR_LEN];
  FILE*fout;
  res=edit_mountlist(mountlist);
  if (res) { finish(1); }
  fout=fopen("/tmp/mountlist.txt","w");
  for(i=0; i< mountlist->entries; i++)
    {
      fprintf(fout,"%-15s %-15s %-15s %8ld\n",mountlist->el[i].device, mountlist->el[i].mountpoint, mountlist->el[i].format, mountlist->el[i].size);
    }
  fclose(fout);
  //  log_to_screen("EXITING FOR TESTING"); finish(99);
  mvaddstr_and_log_it(1,30,"Restoring Interactively");
  if (! destructive_mode)
    {
      log_to_screen("I have finished editing the mountlist for you.");
      return(retval);
    }
  if (ask_me_yes_or_no("Do you want to erase and partition your hard drives?"))
    {
      ptn_errs=partition_everything(mountlist);
      fmt_errs=format_everything(mountlist);
    }
  else
    {
      mvaddstr_and_log_it(g_currentY++,0,"User opted not to partition the devices");
      if (ask_me_yes_or_no("Do you want to format your hard drives?"))
	{
	  fmt_errs=format_everything(mountlist);
	}
      else
	{
	  mvaddstr_and_log_it(g_currentY++,0,"User opted not to partition or format devices");
	}
    }
  if (fmt_errs)
    {
      mvaddstr_and_log_it(g_currentY++,0,"Errors occurred. Please repartition and format drives manually.");
      return(1);
    }
  if (ptn_errs & !fmt_errs)
    {
      mvaddstr_and_log_it(g_currentY++,0,"Errors occurred during partitioning. Formatting, however, went OK.");
    }
  sort_mountlist_by_mountpoint(mountlist,0);
  if (mount_all_devices(mountlist))
    { unmount_all_devices(mountlist); return(1); }

  system("mkdir -p -m 1777 /mnt/RESTORING/tmp");

  if (ask_me_yes_or_no("Do you want me to restore all of your data?"))
    {
      retval+=restore_everything("");
    }
  else if (ask_me_yes_or_no("Do you want me to restore a subset of your data?"))
    {
      if (popup_and_get_string("Restore files","Restore files whose paths contain this string",wildcard))
	{
	  sprintf(tmp,"Restoring subset *%s*",wildcard);
	  mvaddstr_and_log_it(g_currentY++,0,tmp);
	  retval+=restore_everything(wildcard);
	}
    }
  else
    {
      mvaddstr_and_log_it(g_currentY++,0,"User opted not to restore any data.                                  ");
    }
  if (retval)
    { 
      mvaddstr_and_log_it(g_currentY++,0,"Errors occurred during the restore process.            "); 
    }
  if (ask_me_yes_or_no("Run LILO to set up the Master Boot Record?"))
    {
      retval+=run_lilo(TRUE);
    }
  else
    {
      mvaddstr_and_log_it(g_currentY++,0,"User opted not to run LILO.");
    }
  modify_rclocal_one_time("/mnt/RESTORING/etc");
  retval+=unmount_all_devices(mountlist);
  res=system("label-partitions-as-necessary /tmp/mountlist.txt < /tmp/fstab");
  if (res) { log_to_screen("label-partitions-as-necessary returned an error"); }
  retval+=res;
  if (retval)
    {
      mvaddstr_and_log_it(g_currentY++,0,"Warning - errors occurred during the restore phase");
    }
  return(retval);
}




int compare_mode(struct mountlist_itself *mountlist)
{
  int retval=0,res;
  mvaddstr_and_log_it(1,30,"Comparing Automatically");
  sort_mountlist_by_mountpoint(mountlist,0);
  retval=mount_all_devices(mountlist);
  if (retval)
    { unmount_all_devices(mountlist); return(retval); }
  if (does_file_exist("/tmp/TAPEDEV-LIVES-HERE"))
    { retval+=compare_to_tape(""); }
  else
    { retval+=compare_everything(); }
  retval+=unmount_all_devices(mountlist);
  if (retval)
    {
      mvaddstr_and_log_it(g_currentY++,0,"Warning - differences found during the compare phase");
    }
  return(retval);
}




// -----------------------------------------------------------------------


int main(int argc, char*argv[])
{
  int i, c, retval=0, ptn_errs=0, fmt_errs=0, umo_errs=0, lilo_errs=0, restore_errs=0, compare_errs=0,res;
  struct mountlist_itself mountlist, new_mtlist;
  char wildcard[MAX_STR_LEN], tmp[MAX_STR_LEN];

  if (system("fdisk -v"))
    {
      printf("There is a serious problem. I cannot even run 'fdisk -v'.\n");
      printf("Please use the scripts 'restore-mode' and 'compare-mode' instead.\n");
      printf("They are deprecated but oh well, they're better than nothing.\n");
      exit(1);
    }
  
  /* setup */
  setup_newt_stuff();
  unlink(MONDO_LOGFILE);

  /*
  sprintf(g_tape_device,"/dev/st0");
  g_tape_size=4000; // Megabytes
  interact_with_tape(wildcard,'C',"-r","Comparing blah blah","I am doing some freaky shiznit.","","afio: ");
  finish(0);
  */

  if (does_file_exist("/tmp/TAPEDEV-LIVES-HERE"))
    { 
      strcpy(g_tape_device,last_line_of_file("/tmp/TAPEDEV-LIVES-HERE")); 
      sprintf(tmp,"Backup medium is TAPE --- dev=%s",g_tape_device);
      strcpy(tmp,last_line_of_file("/tmp/TAPESIZE"));
      g_tape_size=atol(tmp);
      if (g_tape_size<5)
	{ log_it("WARNING - really mind-numbingly stupid tape size"); }
      log_it(tmp);
    }
  else
    {
      g_tape_device[0]='\0'; 
      log_it("Backup medium is CD-R[W]");
    }
  retval=load_mountlist(&mountlist,"/tmp/mountlist.txt");
  if (retval) { finish(1); }


  /*
  log_to_screen("-------------testing-----------");
  system("cd /mnt/RESTORING");
  restore_from_tape("");
  finish(0);
  */


  if (argc==2 && strcmp(argv[1],"--nuke")==0)
    { retval=nuke_mode(&mountlist); }
  else if (argc==2 && strcmp(argv[1],"--interactive")==0)
    { retval=interactive_mode(&mountlist,TRUE); }
  else if (argc==2 && strcmp(argv[1],"--compare")==0)
    { retval=compare_mode(&mountlist); }
  else if (argc==2 && strcmp(argv[1],"--edit-mountlist")==0)
    { retval=interactive_mode(&mountlist,FALSE); }
  else if (argc!=1)
    {
      log_to_screen("Invalid parameters");
      finish(1);
    }
  else
    {
      c=which_restore_mode();
      if (c=='I') { retval+=interactive_mode(&mountlist,TRUE); }
      else if (c=='N') { retval+=nuke_mode(&mountlist); }
      else if (c=='C') { retval+=compare_mode(&mountlist); }
      else {popup_and_OK("No restoring or comparing will take place today.");}
    }
  if (retval)
    {
      if (c=='C')
	{
	  mvaddstr_and_log_it(g_currentY++,0,"Run complete. See /tmp/changed.txt for list of files that have changed.");
	}
      else
	{
	  mvaddstr_and_log_it(g_currentY++,0,"Run complete. Errors were reported. Please run 'bug-me'.");
	}
    }
  else
    {
      if (!g_tape_device[0])
	{
	  system("sync");
	  res=run_program_and_log_output("umount /mnt/cdrom");
	  //	 if (res) { log_to_screen("WARNING - failed to unmount CD-ROM drive"); }
	  res=run_program_and_log_output("eject /mnt/cdrom");
	  if (res) { log_to_screen("WARNING - failed to eject CD-ROM disk"); }
	  mvaddstr_and_log_it(g_currentY++,0,"Run complete. Please remove the CD and reboot.");
	}
      else
	{
	  mvaddstr_and_log_it(g_currentY++,0,"Run complete. Please remove tape+floppy and reboot.");
	}
    }
  finish(retval);
}



int do_my_funky_lvm_stuff(struct mountlist_itself *mountlist)
{
  char tmp[MAX_STR_LEN],incoming[MAX_STR_LEN],command[MAX_STR_LEN],*p;
  int retval=0,res=0;
  FILE*fin;
  fin=fopen("/tmp/i-want-my-lvm","r");
  if (!fin) {return(1);}
  log_it("OK, opened i-want-my-lvm. Doing funky stuff...");
  for(fgets(incoming,512,fin); !feof(fin); fgets(incoming,512,fin))
    {
      if (incoming[0]!='#') {continue;}
      for(p=incoming+1;*p==' ';p++);
      strcpy(command,p);
      for(p=command;*p!='\0';p++);
      for(;*(p-1)<32;p--);
      *p='\0';
      res=run_program_and_log_output(command);
      sprintf(tmp,"'%s' returned %d",command,res);
      log_it(tmp);
    }
  fclose(fin);
  log_it("Closed i-want-my-lvm. Finished doing funky stuff.");
  return(retval);
}
