/*  
mondo-tools.c

Created on Sept 1st, 2001
*/



#include "my-stuff.h"


// global vase - er, vars
long g_maximum_progress=999, g_current_progress=-999, g_start_time=0;
int g_currentY=3, g_current_cd_number=1;


// externs
extern void finish(int);
extern void setup_newt_stuff(void);
extern char which_restore_mode(void);
extern int ask_me_yes_or_no(char*);
extern void log_to_screen(char*);
extern void update_progress_form(char*);
extern void open_progress_form(char*,char*,char*,char*,long);
extern void close_progress_form(void);
extern void popup_and_OK(char*);
extern int  popup_and_get_string(char*,char*,char*);
extern char MONDO_LOGFILE[MAX_STR_LEN];

/* ------------------ my tools ------------------ */
void sort_mountlist_by_device(struct mountlist_itself*);
long get_time(void);
void log_it(char*);
int run_program_and_log_output(char*);
int is_this_device_mounted(char*);
int does_partition_exist(char*device,int partno);
int strcmp_inc_numbers(char*,char*);
long count_lines_in_file(char*);
long length_of_file(char*);
long noof_lines_that_match_wildcard(char*,char*);
char *slice_fname(long bigfileno, long sliceno, bool zipped, char *path);
char *last_line_of_file(char*filename);
bool does_file_exist(char*);



long get_time()
{
  FILE*fin;
  char incoming[MAX_STR_LEN];
  fin=popen("date +%s","r");
  fgets(incoming,MAX_STR_LEN-1,fin);
  fclose(fin);
  return(atol(incoming));
}



void log_it(char *output)
{
  FILE*fout;
  char ch;
  int i;
  fout=fopen(MONDO_LOGFILE,"a");
  if (fout)
    {
      fprintf(fout,"%s\n",output);
      fclose(fout);
    }
}



int run_program_and_log_output(char *program)
{
  char callstr[MAX_STR_LEN], *p, incoming[MAX_STR_LEN], tmp[MAX_STR_LEN];
  int res, i, len;
  FILE*fin;
  sprintf(callstr,"%s &> /tmp/run-prog.tmp",program);
  while(p=strchr(callstr,'\r')) {*p=' ';}
  while(p=strchr(callstr,'\n')) {*p=' ';}
  res=system(callstr);
  len=strlen(program);
  for(i=0;i<35-len/2;i++) { tmp[i]='-'; }
  tmp[i]='\0';
  strcat(tmp," ");
  strcat(tmp,program);
  strcat(tmp," ");
  for(i=0;i<35-len/2;i++) { strcat(tmp,"-"); }
  log_it(tmp);
  fin=fopen("/tmp/run-prog.tmp","r");
  if (fin)
    {
      for(fgets(incoming,MAX_STR_LEN,fin); !feof(fin); fgets(incoming,MAX_STR_LEN,fin))
	{
	  for(i=0; incoming[i]!='\0'; i++);
	  for(; i>0 && incoming[i-1]>=32; i--);
	  incoming[i]='\0';
	  log_it(incoming);
	}
      fclose(fin);
    }
  log_it("--------------------------------end of output------------------------------");
  if (res) { log_it("...ran with errors."); }
  // else { log_it("...ran just fine. :-)"); }
  return(res);
}



int is_this_device_mounted(char *device_raw)
{
  FILE*fin;
  char incoming[MAX_STR_LEN], device_with_tab[MAX_STR_LEN], device_with_space[MAX_STR_LEN];
  sprintf(device_with_tab,"%s\t",device_raw);
  sprintf(device_with_space,"%s ",device_raw);
  fin=popen("mount","r");
  for(fgets(incoming,MAX_STR_LEN-1,fin); !feof(fin); fgets(incoming,MAX_STR_LEN-1,fin))
    {
      if (strstr(incoming,device_with_space) || strstr(incoming,device_with_tab))
	{
	  fclose(fin);
	  return(1);
	}
    }
  fclose(fin);
  return(0);
}


int does_partition_exist(char *drive, int partno)
{
  char program[MAX_STR_LEN], incoming[MAX_STR_LEN], searchstr[MAX_STR_LEN];
  int res=0;
  FILE *fin;
  sprintf(searchstr,"%s%d ",drive,partno);
  sprintf(program,"fdisk -l %s",drive);
  fin=popen(program,"r");
  if (!fin) {return(0);}
  fgets(incoming,MAX_STR_LEN-1,fin);
  for(res=0; !feof(fin) && !res; fgets(incoming,MAX_STR_LEN-1,fin))
    {
      if (strstr(incoming,searchstr)) 
	{ 
	  res=1;
	}
    }
  fclose(fin);
  return(res);
}




int strcmp_inc_numbers(char*stringA, char*stringB)
{
  int i, diff=0, start_of_numbers_in_A, start_of_numbers_in_B, res;
  long numA,numB;
  char tmp[MAX_STR_LEN];
  if (strlen(stringA)==strlen(stringB)) { return(strcmp(stringA,stringB)); }
  for(i=strlen(stringA); i>0 && isdigit(stringA[i-1]); i--);
  if (i==strlen(stringA)) { return(strcmp(stringA,stringB)); }
  start_of_numbers_in_A = i;
  for(i=strlen(stringB); i>0 && isdigit(stringB[i-1]); i--);
  if (i==strlen(stringB)) { return(strcmp(stringA,stringB)); }
  start_of_numbers_in_B = i;
  if (start_of_numbers_in_A != start_of_numbers_in_B)
    { return(strcmp(stringA,stringB)); }
  res=strncmp(stringA,stringB,i);
  if (res) { return(res); }
  numA = atol(stringA+start_of_numbers_in_A);
  numB = atol(stringB+start_of_numbers_in_B);
  //sprintf(tmp,"Comparing %s and %s --> %ld,%ld\n",stringA,stringB,numA,numB);
  //log_to_screen(tmp);
  return(numA-numB);
}





long count_lines_in_file(char *filename)
{
  char command[MAX_STR_LEN],incoming[MAX_STR_LEN],tmp[MAX_STR_LEN],*p;
  long noof_lines=-1L;
  FILE*fin;
  incoming[0]='\0';

  if (!does_file_exist(filename))
    {
      sprintf(tmp,"%s does not exist, so I cannot found the number of lines in it",filename);
      log_it(tmp);
      return(0);
    }

  /*
  fin=fopen(filename,"r");
  if (!fin) { return(-1); }
  for(noof_lines=0,fgets(tmp,MAX_STR_LEN-1,fin); !feof(fin);fgets(tmp,MAX_STR_LEN-1,fin))
    { noof_lines++; }
  fclose(fin);
  */

  sprintf(command,"grep -n \"\" %s | tail -n1 | cut -d':' -f1",filename);
  fin=popen(command,"r");
  if (fin)
    {
      fgets(incoming,MAX_STR_LEN-1,fin);
      fclose(fin);
      while (incoming[strlen(incoming)-1]<32) 
	{ incoming[strlen(incoming)-1]='\0'; }
      noof_lines=atol(incoming);
      /*
      sprintf(tmp,"count_lines_in_file --> %s --> %ld",incoming,noof_lines);
      log_it(tmp);
      */
    }
  return(noof_lines);
}


long length_of_file(char *filename)
{
  FILE*fin;
  long length;
  fin=fopen(filename,"r");
  if (!fin)
    {return(-1);}
  fseek(fin,0,SEEK_END);
  length=ftell(fin);
  fclose(fin);
  return(length);
}



long noof_lines_that_match_wildcard(char*filelist_fname, char *wildcard)
{
  long matches=0;
  FILE*fin;
  char incoming[MAX_STR_LEN];
  fin=fopen(filelist_fname,"r");
  if (!fin) { return(0); }
  fgets(incoming,MAX_STR_LEN-1,fin);
  while(!feof(fin))
    {
      if (strstr(incoming,wildcard))
	{
	  matches++;
	}
      fgets(incoming,MAX_STR_LEN-1,fin);
    }
  fclose(fin);
  return(matches);
}




bool does_file_exist(char*filename)
{
  int res;
  res=length_of_file(filename);
  if (res>=0) { return(TRUE); } else { return(FALSE); }
}



char *slice_fname(long bigfileno, long sliceno, bool zipped, char*path)
{
  static char output[MAX_STR_LEN];
  sprintf(output,"%s/slice-%07ld.%05ld.dat",path,bigfileno,sliceno);
  if (zipped)
    {
      strcat(output,".bz2");
    }
  return(output);
}


char *last_line_of_file(char*filename)
{
  static char output[MAX_STR_LEN],command[MAX_STR_LEN],tmp[MAX_STR_LEN];
  FILE*fin;
  if (!does_file_exist(filename))
    {
      sprintf(tmp,"Tring to get last line of nonexistent file (%s)",filename);
      log_it(tmp);
      output[0]='\0';
      return(output);
    }
  sprintf(command,"cat %s | tail -n1",filename);
  fin=popen(command,"r");
  fgets(output,MAX_STR_LEN,fin);
  pclose(fin);
  while (output[strlen(output)-1]<32)
    { output[strlen(output)-1]='\0'; }
  log_it(output);
  return(output);
}




